-- phpMyAdmin SQL Dump
-- version 3.4.7
-- http://www.phpmyadmin.net
--
-- Host: localhost
-- Generation Time: Jan 25, 2012 at 02:52 AM
-- Server version: 5.1.39
-- PHP Version: 5.2.11

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";

--
-- Database: `youdesigns`
--

-- --------------------------------------------------------

--
-- Table structure for table `#__assets`
--

DROP TABLE IF EXISTS `#__assets`;
CREATE TABLE IF NOT EXISTS `#__assets` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `parent_id` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set parent.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `level` int(10) unsigned NOT NULL COMMENT 'The cached level in the nested tree.',
  `name` varchar(50) NOT NULL COMMENT 'The unique name for the asset.\n',
  `title` varchar(100) NOT NULL COMMENT 'The descriptive title for the asset.',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_asset_name` (`name`),
  KEY `idx_lft_rgt` (`lft`,`rgt`),
  KEY `idx_parent_id` (`parent_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=48 ;

--
-- Dumping data for table `#__assets`
--

INSERT INTO `#__assets` (`id`, `parent_id`, `lft`, `rgt`, `level`, `name`, `title`, `rules`) VALUES
(1, 0, 1, 442, 0, 'root.1', 'Root Asset', '{"core.login.site":{"6":1,"2":1},"core.login.admin":{"6":1},"core.admin":{"8":1},"core.manage":{"7":1},"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
(2, 1, 1, 2, 1, 'com_admin', 'com_admin', '{}'),
(3, 1, 3, 6, 1, 'com_banners', 'com_banners', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(4, 1, 7, 8, 1, 'com_cache', 'com_cache', '{"core.admin":{"7":1},"core.manage":{"7":1}}'),
(5, 1, 9, 10, 1, 'com_checkin', 'com_checkin', '{"core.admin":{"7":1},"core.manage":{"7":1}}'),
(6, 1, 11, 12, 1, 'com_config', 'com_config', '{}'),
(7, 1, 13, 16, 1, 'com_contact', 'com_contact', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(8, 1, 17, 48, 1, 'com_content', 'com_content', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":{"3":1},"core.delete":[],"core.edit":{"4":1},"core.edit.state":{"5":1},"core.edit.own":[]}'),
(9, 1, 49, 50, 1, 'com_cpanel', 'com_cpanel', '{}'),
(10, 1, 51, 52, 1, 'com_installer', 'com_installer', '{"core.admin":{"7":1},"core.manage":{"7":1},"core.delete":[],"core.edit.state":[]}'),
(11, 1, 53, 54, 1, 'com_languages', 'com_languages', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(12, 1, 55, 56, 1, 'com_login', 'com_login', '{}'),
(13, 1, 57, 58, 1, 'com_mailto', 'com_mailto', '{}'),
(14, 1, 59, 60, 1, 'com_massmail', 'com_massmail', '{}'),
(15, 1, 61, 62, 1, 'com_media', 'com_media', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":{"3":1},"core.delete":{"5":1}}'),
(16, 1, 63, 64, 1, 'com_menus', 'com_menus', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(17, 1, 65, 66, 1, 'com_messages', 'com_messages', '{"core.admin":{"7":1},"core.manage":{"7":1}}'),
(18, 1, 67, 68, 1, 'com_modules', 'com_modules', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(19, 1, 69, 72, 1, 'com_newsfeeds', 'com_newsfeeds', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(20, 1, 73, 74, 1, 'com_plugins', 'com_plugins', '{"core.admin":{"7":1},"core.manage":[],"core.edit":[],"core.edit.state":[]}'),
(21, 1, 75, 76, 1, 'com_redirect', 'com_redirect', '{"core.admin":{"7":1},"core.manage":[]}'),
(22, 1, 77, 78, 1, 'com_search', 'com_search', '{"core.admin":{"7":1},"core.manage":{"6":1}}'),
(23, 1, 79, 80, 1, 'com_templates', 'com_templates', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(24, 1, 81, 82, 1, 'com_users', 'com_users', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.own":{"6":1},"core.edit.state":[]}'),
(25, 1, 83, 86, 1, 'com_weblinks', 'com_weblinks', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":{"3":1},"core.delete":[],"core.edit":{"4":1},"core.edit.state":{"5":1},"core.edit.own":[]}'),
(26, 1, 87, 88, 1, 'com_wrapper', 'com_wrapper', '{}'),
(27, 8, 18, 35, 2, 'com_content.category.2', 'Latest', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(28, 3, 4, 5, 2, 'com_banners.category.3', 'Uncategorised', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(43, 7, 14, 15, 2, 'com_contact.category.8', 'Site contact', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(30, 19, 70, 71, 2, 'com_newsfeeds.category.5', 'Joomla News Feeds', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(31, 25, 84, 85, 2, 'com_weblinks.category.6', 'Recomended Weblinks', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(32, 27, 19, 20, 3, 'com_content.article.1', 'News Item1', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(33, 27, 21, 22, 3, 'com_content.article.2', 'News Item2', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(34, 27, 23, 24, 3, 'com_content.article.3', 'News Item3', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(35, 27, 25, 26, 3, 'com_content.article.4', 'News Item4', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(36, 27, 27, 28, 3, 'com_content.article.5', 'News Item5', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(37, 27, 29, 30, 3, 'com_content.article.6', 'News Item6', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(38, 27, 31, 32, 3, 'com_content.article.7', 'News Item7', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(39, 8, 36, 47, 2, 'com_content.category.7', 'Template Settings', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(40, 39, 37, 38, 3, 'com_content.article.8', 'Sample News item', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(41, 39, 41, 42, 3, 'com_content.article.9', 'YJ SimpleGrid Framework Features ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(42, 39, 39, 40, 3, 'com_content.article.10', 'YJSG Mega Menu Instructions ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(44, 27, 33, 34, 3, 'com_content.article.11', 'Archived Article', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(45, 39, 43, 44, 3, 'com_content.article.12', 'Typography', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(46, 39, 45, 46, 3, 'com_content.article.13', 'YJSG Module Positions', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}');

-- --------------------------------------------------------

--
-- Table structure for table `#__associations`
--

DROP TABLE IF EXISTS `#__associations`;
CREATE TABLE IF NOT EXISTS `#__associations` (
  `id` varchar(50) NOT NULL COMMENT 'A reference to the associated item.',
  `context` varchar(50) NOT NULL COMMENT 'The context of the associated item.',
  `key` char(32) NOT NULL COMMENT 'The key for the association computed from an md5 on associated ids.',
  PRIMARY KEY (`context`,`id`),
  KEY `idx_key` (`key`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `#__banners`
--

DROP TABLE IF EXISTS `#__banners`;
CREATE TABLE IF NOT EXISTS `#__banners` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) NOT NULL DEFAULT '0',
  `type` int(11) NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `imptotal` int(11) NOT NULL DEFAULT '0',
  `impmade` int(11) NOT NULL DEFAULT '0',
  `clicks` int(11) NOT NULL DEFAULT '0',
  `clickurl` varchar(200) NOT NULL DEFAULT '',
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `description` text NOT NULL,
  `custombannercode` varchar(2048) NOT NULL,
  `sticky` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `params` text NOT NULL,
  `own_prefix` tinyint(1) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `reset` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `language` char(7) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `idx_state` (`state`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`),
  KEY `idx_banner_catid` (`catid`),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Table structure for table `#__banner_clients`
--

DROP TABLE IF EXISTS `#__banner_clients`;
CREATE TABLE IF NOT EXISTS `#__banner_clients` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `contact` varchar(255) NOT NULL DEFAULT '',
  `email` varchar(255) NOT NULL DEFAULT '',
  `extrainfo` text NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `metakey` text NOT NULL,
  `own_prefix` tinyint(4) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  PRIMARY KEY (`id`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Table structure for table `#__banner_tracks`
--

DROP TABLE IF EXISTS `#__banner_tracks`;
CREATE TABLE IF NOT EXISTS `#__banner_tracks` (
  `track_date` datetime NOT NULL,
  `track_type` int(10) unsigned NOT NULL,
  `banner_id` int(10) unsigned NOT NULL,
  `count` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`track_date`,`track_type`,`banner_id`),
  KEY `idx_track_date` (`track_date`),
  KEY `idx_track_type` (`track_type`),
  KEY `idx_banner_id` (`banner_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `#__categories`
--

DROP TABLE IF EXISTS `#__categories`;
CREATE TABLE IF NOT EXISTS `#__categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `lft` int(11) NOT NULL DEFAULT '0',
  `rgt` int(11) NOT NULL DEFAULT '0',
  `level` int(10) unsigned NOT NULL DEFAULT '0',
  `path` varchar(255) NOT NULL DEFAULT '',
  `extension` varchar(50) NOT NULL DEFAULT '',
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `description` mediumtext,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `access` int(10) unsigned DEFAULT NULL,
  `params` text NOT NULL,
  `metadesc` varchar(1024) NOT NULL COMMENT 'The meta description for the page.',
  `metakey` varchar(1024) NOT NULL COMMENT 'The meta keywords for the page.',
  `metadata` varchar(2048) NOT NULL COMMENT 'JSON encoded metadata properties.',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `cat_idx` (`extension`,`published`,`access`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_path` (`path`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=9 ;

--
-- Dumping data for table `#__categories`
--

INSERT INTO `#__categories` (`id`, `asset_id`, `parent_id`, `lft`, `rgt`, `level`, `path`, `extension`, `title`, `alias`, `note`, `description`, `published`, `checked_out`, `checked_out_time`, `access`, `params`, `metadesc`, `metakey`, `metadata`, `created_user_id`, `created_time`, `modified_user_id`, `modified_time`, `hits`, `language`) VALUES
(1, 0, 0, 0, 13, 0, '', 'system', 'ROOT', 'root', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{}', '', '', '', 0, '2009-10-18 16:07:09', 0, '0000-00-00 00:00:00', 0, '*'),
(2, 27, 1, 1, 2, 1, 'latest', 'com_content', 'Latest', 'latest', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-06-28 13:26:37', 42, '2011-01-27 14:52:57', 0, '*'),
(3, 28, 1, 3, 4, 1, 'uncategorised', 'com_banners', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":"","foobar":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-06-28 13:27:35', 0, '0000-00-00 00:00:00', 0, '*'),
(5, 30, 1, 5, 6, 1, 'joomla-news-feeds', 'com_newsfeeds', 'Joomla News Feeds', 'joomla-news-feeds', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-06-28 13:28:15', 42, '2011-01-29 15:24:39', 0, '*'),
(6, 31, 1, 7, 8, 1, 'recomended-weblinks', 'com_weblinks', 'Recomended Weblinks', 'recomended-weblinks', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-06-28 13:28:33', 42, '2011-01-29 14:01:48', 0, '*'),
(7, 39, 1, 9, 10, 1, 'template-settings', 'com_content', 'Template Settings', 'template-settings', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-01-27 15:11:41', 0, '0000-00-00 00:00:00', 0, '*'),
(8, 43, 1, 11, 12, 1, 'site-contact', 'com_contact', 'Site contact', 'site-contact', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-01-29 14:30:28', 0, '0000-00-00 00:00:00', 0, '*');

-- --------------------------------------------------------

--
-- Table structure for table `#__contact_details`
--

DROP TABLE IF EXISTS `#__contact_details`;
CREATE TABLE IF NOT EXISTS `#__contact_details` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `con_position` varchar(255) DEFAULT NULL,
  `address` text,
  `suburb` varchar(100) DEFAULT NULL,
  `state` varchar(100) DEFAULT NULL,
  `country` varchar(100) DEFAULT NULL,
  `postcode` varchar(100) DEFAULT NULL,
  `telephone` varchar(255) DEFAULT NULL,
  `fax` varchar(255) DEFAULT NULL,
  `misc` mediumtext,
  `image` varchar(255) DEFAULT NULL,
  `imagepos` varchar(20) DEFAULT NULL,
  `email_to` varchar(255) DEFAULT NULL,
  `default_con` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `user_id` int(11) NOT NULL DEFAULT '0',
  `catid` int(11) NOT NULL DEFAULT '0',
  `access` int(10) unsigned DEFAULT NULL,
  `mobile` varchar(255) NOT NULL DEFAULT '',
  `webpage` varchar(255) NOT NULL DEFAULT '',
  `sortname1` varchar(255) NOT NULL,
  `sortname2` varchar(255) NOT NULL,
  `sortname3` varchar(255) NOT NULL,
  `language` char(7) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=5 ;

--
-- Dumping data for table `#__contact_details`
--

INSERT INTO `#__contact_details` (`id`, `name`, `alias`, `con_position`, `address`, `suburb`, `state`, `country`, `postcode`, `telephone`, `fax`, `misc`, `image`, `imagepos`, `email_to`, `default_con`, `published`, `checked_out`, `checked_out_time`, `ordering`, `params`, `user_id`, `catid`, `access`, `mobile`, `webpage`, `sortname1`, `sortname2`, `sortname3`, `language`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `featured`, `xreference`, `publish_up`, `publish_down`) VALUES
(4, 'Publisher', 'publisher', 'Publisher', '', 'Miami', 'Florida', 'USA', '', '555555', '', '', 'images/powered_by.png', NULL, '', 0, 1, 0, '0000-00-00 00:00:00', 2, '{"show_contact_category":"","show_contact_list":"","presentation_style":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_profile":"","show_links":"","linka_name":"","linka":"","linkb_name":"","linkb":"","linkc_name":"","linkc":"","linkd_name":"","linkd":"","linke_name":"","linke":"","contact_layout":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":""}', 46, 8, 1, '', 'http://www.youjoomla.com', '', '', '', '*', '2011-01-29 14:31:28', 42, '', '2011-01-29 15:23:59', 42, '', '', '{"robots":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(3, 'Admin', 'admin', 'Administrator', '', 'Miami', 'Florida', 'USA', '', '555555', '', '', '', NULL, '', 0, 1, 0, '0000-00-00 00:00:00', 1, '{"show_contact_category":"hide","show_contact_list":"","presentation_style":"plain","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_profile":"","show_links":"","linka_name":"","linka":"","linkb_name":"","linkb":"","linkc_name":"","linkc":"","linkd_name":"","linkd":"","linke_name":"","linke":"","contact_layout":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":""}', 42, 8, 1, '', 'http://www.youjoomla.com', '', '', '', '*', '2011-01-29 14:30:52', 42, '', '2011-01-29 15:21:26', 42, '', '', '{"robots":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00');

-- --------------------------------------------------------

--
-- Table structure for table `#__content`
--

DROP TABLE IF EXISTS `#__content`;
CREATE TABLE IF NOT EXISTS `#__content` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `title` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `title_alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '' COMMENT 'Deprecated in Joomla! 3.0',
  `introtext` mediumtext NOT NULL,
  `fulltext` mediumtext NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `sectionid` int(10) unsigned NOT NULL DEFAULT '0',
  `mask` int(10) unsigned NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `images` text NOT NULL,
  `urls` text NOT NULL,
  `attribs` varchar(5120) NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `parentid` int(10) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `language` char(7) NOT NULL COMMENT 'The language code for the article.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=15 ;

--
-- Dumping data for table `#__content`
--

INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(1, 32, 'News Item1', 'news-item1', '', '<p>Vivamus porta eros et neque vulputate pretium. Viva mus vel velit metus, scelerisque molestie augue. Aliquam semper hendrerit velit, at convallis augue pel lentesque vel.Donec sed accumsan sem. Nunc feugiat elit eu nisi laci nia consequat. Mauris sed erat sit amet nibh aliquet Duis nisi sapien, feugiat tem</p>\r\n', '\r\n<p>Vivamus porta eros et neque vulputate pretium. Viva mus vel velit metus, scelerisque molestie augue. Aliquam semper hendrerit velit, at convallis augue pel lentesque vel.Donec sed accumsan sem. Nunc feugiat elit eu nisi laci nia consequat. Mauris sed erat sit amet nibh aliquet Duis nisi sapien, feugiat tem</p>\r\n<br />', 1, 0, 0, 2, '2011-01-27 14:53:20', 42, '', '2011-01-27 16:12:29', 42, 0, '0000-00-00 00:00:00', '2011-01-27 14:53:20', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 0, 7, '', '', 1, 107, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(2, 33, 'News Item2', 'news-item2', '', '<p>Vivamus porta eros et neque vulputate pretium. Viva mus vel velit metus, scelerisque molestie augue. Aliquam semper hendrerit velit, at convallis augue pel lentesque vel.Donec sed accumsan sem. Nunc feugiat elit eu nisi laci nia consequat. Mauris sed erat sit amet nibh aliquet Duis nisi sapien, feugiat tem</p>\r\n', '\r\n<p>Vivamus porta eros et neque vulputate pretium. Viva mus vel velit metus, scelerisque molestie augue. Aliquam semper hendrerit velit, at convallis augue pel lentesque vel.Donec sed accumsan sem. Nunc feugiat elit eu nisi laci nia consequat. Mauris sed erat sit amet nibh aliquet Duis nisi sapien, feugiat tem</p>\r\n<br />', 1, 0, 0, 2, '2011-01-27 14:53:39', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2011-01-27 14:53:39', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 6, '', '', 1, 45, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(3, 34, 'News Item3', 'news-item3', '', '<p>Vivamus porta eros et neque vulputate pretium. Viva mus vel velit metus, scelerisque molestie augue. Aliquam semper hendrerit velit, at convallis augue pel lentesque vel.Donec sed accumsan sem. Nunc feugiat elit eu nisi laci nia consequat. Mauris sed erat sit amet nibh aliquet Duis nisi sapien, feugiat tem</p>\r\n', '\r\n<p>Vivamus porta eros et neque vulputate pretium. Viva mus vel velit metus, scelerisque molestie augue. Aliquam semper hendrerit velit, at convallis augue pel lentesque vel.Donec sed accumsan sem. Nunc feugiat elit eu nisi laci nia consequat. Mauris sed erat sit amet nibh aliquet Duis nisi sapien, feugiat tem</p>\r\n<br />', 1, 0, 0, 2, '2011-01-27 14:53:48', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2011-01-27 14:53:48', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 5, '', '', 1, 65, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(4, 35, 'News Item4', 'news-item4', '', '<p>Vivamus porta eros et neque vulputate pretium. Viva mus vel velit metus, scelerisque molestie augue. Aliquam semper hendrerit velit, at convallis augue pel lentesque vel.Donec sed accumsan sem. Nunc feugiat elit eu nisi laci nia consequat. Mauris sed erat sit amet nibh aliquet Duis nisi sapien, feugiat tem</p>\r\n', '\r\n<p>Vivamus porta eros et neque vulputate pretium. Viva mus vel velit metus, scelerisque molestie augue. Aliquam semper hendrerit velit, at convallis augue pel lentesque vel.Donec sed accumsan sem. Nunc feugiat elit eu nisi laci nia consequat. Mauris sed erat sit amet nibh aliquet Duis nisi sapien, feugiat tem</p>\r\n<br />', 1, 0, 0, 2, '2011-01-27 14:53:57', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2011-01-27 14:53:57', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 4, '', '', 1, 14, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(5, 36, 'News Item5', 'news-item5', '', '<p>Vivamus porta eros et neque vulputate pretium. Viva mus vel velit metus, scelerisque molestie augue. Aliquam semper hendrerit velit, at convallis augue pel lentesque vel.Donec sed accumsan sem. Nunc feugiat elit eu nisi laci nia consequat. Mauris sed erat sit amet nibh aliquet Duis nisi sapien, feugiat tem</p>\r\n', '\r\n<p>Vivamus porta eros et neque vulputate pretium. Viva mus vel velit metus, scelerisque molestie augue. Aliquam semper hendrerit velit, at convallis augue pel lentesque vel.Donec sed accumsan sem. Nunc feugiat elit eu nisi laci nia consequat. Mauris sed erat sit amet nibh aliquet Duis nisi sapien, feugiat tem</p>\r\n<br />', 1, 0, 0, 2, '2011-01-27 14:54:05', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2011-01-27 14:54:05', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 3, '', '', 1, 4, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(6, 37, 'News Item6', 'news-item6', '', '<p>Vivamus porta eros et neque vulputate pretium. Viva mus vel velit metus, scelerisque molestie augue. Aliquam semper hendrerit velit, at convallis augue pel lentesque vel.Donec sed accumsan sem. Nunc feugiat elit eu nisi laci nia consequat. Mauris sed erat sit amet nibh aliquet Duis nisi sapien, feugiat tem</p>\r\n', '\r\n<p>Vivamus porta eros et neque vulputate pretium. Viva mus vel velit metus, scelerisque molestie augue. Aliquam semper hendrerit velit, at convallis augue pel lentesque vel.Donec sed accumsan sem. Nunc feugiat elit eu nisi laci nia consequat. Mauris sed erat sit amet nibh aliquet Duis nisi sapien, feugiat tem</p>\r\n<br />', 1, 0, 0, 2, '2011-01-27 14:54:14', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2011-01-27 14:54:14', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 2, '', '', 1, 5, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(7, 38, 'News Item7', 'news-item7', '', '<p>Vivamus porta eros et neque vulputate pretium. Viva mus vel velit metus, scelerisque molestie augue. Aliquam semper hendrerit velit, at convallis augue pel lentesque vel.Donec sed accumsan sem. Nunc feugiat elit eu nisi laci nia consequat. Mauris sed erat sit amet nibh aliquet Duis nisi sapien, feugiat tem</p>\r\n', '\r\n<p>Vivamus porta eros et neque vulputate pretium. Viva mus vel velit metus, scelerisque molestie augue. Aliquam semper hendrerit velit, at convallis augue pel lentesque vel.Donec sed accumsan sem. Nunc feugiat elit eu nisi laci nia consequat. Mauris sed erat sit amet nibh aliquet Duis nisi sapien, feugiat tem</p>\r\n<br />', 1, 0, 0, 2, '2011-01-27 14:54:22', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2011-01-27 14:54:22', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 1, '', '', 1, 8, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(8, 40, 'Sample News item', 'sample-news-item', '', 'Praesent posuere tempus nibh bibendum aliquam. Integer ullamcorper vestibulum nisl vitae ullamcorper. Donec fermentum ligula at tortor tincidunt rutrum. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Quisque blandit tellus vitae justo rutrum viverra. Proin semper sapien faucibus dolor ultrices a tempus leo porta. Integer sed lorem nisl, ac tincidunt diam. Sed ante felis, pellentesque in consectetur at, rutrum non turpis. Aenean id pellentesque lacus. Quisque ligula est, aliquam vitae lobortis ornare, posuere sit amet risus. Sed massa lacus, iaculis et venenatis nec, tempor mattis est. Sed placerat placerat volutpat. Integer ut orci metus. Etiam egestas, ante ac fermentum dapibus, arcu est semper odio, nec mattis metus elit eget nunc. Praesent posuere tempus nibh bibendum aliquam. Integer ullamcorper vestibulum nisl vitae ullamcorper. Donec fermentum ligula at tortor tincidunt rutrum. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Quisque blandit tellus vitae justo rutrum viverra. Proin semper sapien faucibus dolor ultrices a tempus leo porta. Integer sed lorem nisl, ac tincidunt diam. Sed ante felis, pellentesque in consectetur at, rutrum non turpis. Aenean id pellentesque lacus. Quisque ligula est, aliquam vitae lobortis ornare, posuere sit amet risus. Sed massa lacus, iaculis et venenatis nec, tempor mattis est. Sed placerat placerat volutpat. Integer ut orci metus. Etiam egestas, ante ac fermentum dapibusInteger ut orci metus. Etiam egestas, ante ac fermentum dapibus', '', 1, 0, 0, 7, '2011-01-27 15:12:11', 42, '', '2011-02-04 14:51:43', 42, 0, '0000-00-00 00:00:00', '2011-01-27 15:12:11', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"0","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 8, 0, 5, '', '', 1, 207, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(9, 41, 'YJ SimpleGrid Framework Features ', 'yj-simplegrid-framework-features', '', '<p>YJSG is loaded with new features and  checks out all points of   Joomla! web development including , security , design , coding standards   and site speed. From array of features we would like to name a few and   give you a short insight in to new joomla template coding standards.</p>\r\n<br />\r\n<h2><strong>List of YJSimpleGrid Key Features:</strong></h2>\r\n<br />\r\n<ul>\r\n<li><strong><a href="http://www.joomla1.5.youjoomla.info/yougrids/yjsg-framework/template-manager.html" target="_blank">Advanced Joomla Template Manager Admin Panel</a></strong></li>\r\n<li>Flexible Layouts</li>\r\n<li>Over 51 collapsible module positions easily add more</li>\r\n<li>Automatic module width adjustments in template manager</li>\r\n<li>Native RTL</li>\r\n<li>Native Mobile devices support</li>\r\n<li>Enhanced SEO features to increase your site visibility</li>\r\n<li>Custom iPhone/iPad/iPod and handheld devices template</li>\r\n<li>Cross browser support</li>\r\n<li>Native Cufon and Google Font plus 15 CSS font styles</li>\r\n<li>Native Jquery Support</li>\r\n<li>Native rounded and square module styles 1 click switch</li>\r\n<li>1 image PNG transparent rounded corners approach for easy editing</li>\r\n<li>Component off switch or menu item assignment</li>\r\n<li>Topmenu off switch or menu item assignment</li>\r\n<li>7 default module grids with 5 modules each. Easily add more</li>\r\n<li>Flexible logo and header size changer</li>\r\n<li>Upgraded server side compression</li>\r\n<li>Frontpage news items number of  characters control</li>\r\n<li>Visible RTL switch and Font resizer</li>\r\n<li>5 menu types</li>\r\n<li><strong><a href="index.php?option=com_content&amp;view=article&amp;id=10&amp;Itemid=124">Yj Mega Menu</a></strong></li>\r\n<li>Custom error and offline pages</li>\r\n<li>Custom user pages ( com_users )</li>\r\n<li>Slide to top smothscroll</li>\r\n<li>XHTML , CSS and JS valid</li>\r\n</ul>\r\n<br />\r\n<br />', '', 1, 0, 0, 7, '2011-01-27 15:13:12', 42, '', '2011-01-31 10:09:09', 42, 0, '0000-00-00 00:00:00', '2011-01-27 15:13:12', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"0","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 8, 0, 3, '', '', 1, 68, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(10, 42, 'YJSG Mega Menu Instructions ', 'yjsg-mega-menu-instructions', '', '<br />\r\n<p><img src="images/YJSGMMI/Mega-Menu-Schema.jpg" border="0" alt="Mega-Menu-Schema" /></p>\r\n<p>A new feature of all <strong>YJSG powered templates is the powerful YJ Mega Menu</strong>. In order for this menu to work all you have to do is install and enable the <strong>YJ MegaMenu plugin</strong> in the backend. Next you set the width of the dropdown in the template manager. <strong>The rest of the settings are all done in the menumanager.</strong></p>\r\n<br />\r\n<h1>Choice of Menu:</h1>\r\n<p>All <strong>YJSG powered templates</strong> with the <strong>YJ Mega Menu</strong> give you the choice between 5 menu types.</p>\r\n<ol>\r\n<li><strong>CSS Dropdown Menu; a dropdown menu displaying the lower levels in columns. </strong></li>\r\n<li><strong>Smooth Dropdown Menu; the same as CSS Dropdown Menu but with a smooth javascript effect added for dropdowns.</strong></li>\r\n<li><strong>CSS Dropline Menu; a dropline menu displaying the first sublevel in line.</strong></li>\r\n<li><strong>Smooth Dropline Menu; the same as CSS Dropline Menu but with a smooth javascript effect added for the dropline and the dropdowns.</strong></li>\r\n<li><strong>Joomla Splitmenu; the old faithfull splitmenu which gives you the ability to display the sublevel menu items in a module position.</strong></li>\r\n</ol>\r\n<p><strong> </strong></p>\r\n<p><strong> </strong>Main Features of <strong>YJ Mega Menu</strong>:</p>\r\n<ul>\r\n<li><strong>Fully CSS driven</strong></li>\r\n<strong> </strong>\r\n<li><strong>Per item styling</strong></li>\r\n<strong> </strong>\r\n<li><strong>Subtitles for all menu items</strong></li>\r\n<strong> </strong>\r\n<li><strong>Menu Images for all menu items</strong></li>\r\n<strong> </strong>\r\n<li><strong>Sub Items descriptions</strong></li>\r\n<strong> </strong>\r\n<li><strong>Two levels deep Group Holders</strong></li>\r\n<strong> </strong>\r\n<li><strong>Eight Levels deep subitems</strong></li>\r\n<strong> </strong>\r\n<li><strong>Loads modules</strong></li>\r\n<strong> </strong>\r\n<li><strong>Loads modulepositions</strong></li>\r\n<strong> </strong>\r\n<li><strong>Cross browser compatible, and degrades functional in IE6</strong></li>\r\n<li><strong>Choice between CSS dropdown menu, smooth dropdown menu, CSS Dropline Menu, Smooth Dropline Menu and Joomla Splitmenu</strong></li>\r\n</ul>\r\n<br />\r\n<p>In this tutorial you see all the possibilities of the <strong>YJ Mega Menu explained</strong>. Let''s see how these very powerful possibilities are set through the backend. This example is about the CSS Dropdown Menu and the Smooth Dropdown Menu.<br /><br /></p>\r\n<h3>1. Menu Images:</h3>\r\n<p><img src="images/YJSGMMI/menu-images.jpg" border="0" alt="menu-images" style="margin: 5px 20px 10px 0px; float: left;" /><strong>Menu images</strong> can be applied on all levels of the menu.</p>\r\n<p>Go to menu manager, main menu, select item and select parameters<em><strong> Link Type Options</strong></em>. Next you can select an menu image from the <em><strong>images </strong></em>directory of your Joomla installation. Select image and hit save.</p>\r\n<p><br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /></p>\r\n<h3>2. Subtitles for menu items:</h3>\r\n<p><br /><img src="images/YJSGMMI/Mega-Menu-Subtitles.jpg" border="0" alt="Mega Menu Subtitles" title="Mega Menu Subtitles" style="margin: 5px 20px 10px 0px; float: left;" />In the menumanager open up mainmenu, menu item and select parameters <strong>YJ Megamenu</strong>. In the subtitle box you can fill in the subtitle for a menu item, in this case YJSG Demo  for the Home menu item. This setting can be applied on all levels.</p>\r\n<p><br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /></p>\r\n<h3><strong>3. Subtitles and menu images can be combined by following both step1 and 2 as above.</strong></h3>\r\n<br />\r\n<h3>4. Act a group holder:</h3>\r\n<p><img src="images/YJSGMMI/Mega-Menu-Groups.jpg" border="0" alt="Mega Menu Groups" title="Mega Menu Groups" style="margin: 5px 20px 10px 0px; float: left;" /></p>\r\n<p>On a per menu item basis you can set a menu item as <strong>group holder</strong>. This can be done 2 levels deep, so you can have a group holder on the first level of the menu, and then another within that group.</p>\r\n<p>Here we have set the menu item to act as a group holder of 720 pixels wide, with 3 subgroups of which the first is 200 pixels, second 300 and third 220pixels wide.<br /><br /><strong>If the width for the subgroups isn''t set the group holder width will be equally distributed over the number of sub groups. You can set up to 6 sub groups. Please note, a group holder can only be a normal link.</strong></p>\r\n<p>The <strong>group holder</strong> itself can be a normal link and any Menu item type like , url , separator , component ect.</p>\r\n<p><br /> <br /> <br /> <br /></p>\r\n<h3>5. Load Modules in YJ Mega Menu:</h3>\r\n<p><img src="images/YJSGMMI/Mega-Menu-Module.jpg" border="0" alt="Mega Menu Module" title="Mega Menu Module" style="margin: 5px 20px 10px 0px; float: left;" />Another important <strong>feauture</strong> of the <strong>YJ Mega Menu</strong> is the ability to load <strong>modules</strong> in the menu.</p>\r\n<p>Here we have set the <strong>Menu Item Type to Module</strong>, and selected module Adv5 to be displayed. Please note, you can select more than one module to be displayed in the menu.</p>\r\n<p>When displaying modules in the menu you can also select to <strong>Display link title, image and sub title if link type is module. </strong>This setting is useful when you want to show a module, for example the login, with only its title.</p>\r\n<p><br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /></p>\r\n<h3>6. Load Module positions in YJ Mega Menu:</h3>\r\n<p><img src="images/YJSGMMI/Mega-Menu-Module-Position-backend.jpg" border="0" alt="Mega Menu Module Position" title="Mega Menu Module Position" style="margin: 5px 20px 10px 0px; float: left;" /></p>\r\n<br />\r\n<p>Besides loading modules you can also load <strong>module positions</strong> in the <strong>YJ Mega Menu</strong>. This is useful for when you have more than one instance of a module installed. Now you can publish the module to a specific module position and load this into your menu.</p>\r\n<p>Here we have selected module position in menu item type and selected module position topmenu1 to be published into the menu.</p>\r\n<p>See picture on top of the page for a module position loaded into the first column of the second group holder.</p>\r\n<p><br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /> <br /></p>\r\n<h3>7. Group Holder in Group Holder</h3>\r\n<p>For the menu item group mix we have set a second level group holder in above example. As all properties for all items on all levels are set on a per item basis, we have given this group different properties. The second group loads 3 groups, each with its own width, and it loads a module position, a group of menu items and a module. <strong>Versatility at its  best!</strong></p>\r\n<h3>Mega Menu from the Menu Manager:</h3>\r\n<p>We have now had a look at the settings of the <strong>parameters</strong> for the <strong>YJ Mega Menu</strong>. To finish the basics of setting up the menu, this is how the menu looks in the menumanager in the backend. You will see all items nested into eachother, resulting in the menu you see at the start of these instructions.</p>\r\n<p><img src="images/YJSGMMI/Mega-Menu-from-menumanager.jpg" border="0" alt="Mega-Menu-from-menumanager" /></p>\r\n<br />\r\n<h3>Dropline Mega Menu:</h3>\r\n<p>As a picture paints a thousand words, a screenshot of the exact same menu as above with the <strong>CSS Dropline Menu</strong> and the <strong>Smooth Dropline Menu</strong>.</p>\r\n<br />\r\n<p><img src="images/YJSGMMI/Dropline-menu.jpg" border="0" alt="Dropline Menu" title="Dropline Menu" /></p>\r\n<br />\r\n<p>As you can see the same <strong>functionality</strong> as for the CSS and the Smooth Dropdown Menu, with the only difference being that the <strong>Dropline Menu</strong> can''t display Groups for obvious reasons.</p>\r\n<br />\r\n<h3>Add custom css class:</h3>\r\n<br />\r\n<h3><img src="images/YJSGMMI/newclass.jpg" border="0" width="479" height="379" style="float: left; margin: 10px;" /></h3>\r\n<p>All you have to do is fill in newclass in the <strong>Add custom css class </strong>box in the <strong>Link Type Options-&gt;Link Css style</strong>. Of course this is just an example, but with this option the sky is really the limit!</p>\r\n<br />\r\n<br />\r\n<br />\r\n<br />\r\n<br />\r\n<br />\r\n<br />\r\n<br />\r\n<br />\r\n<br />\r\n<br />\r\n<br />\r\n<br />\r\n<br />\r\n<br />\r\n<br />\r\n<br />\r\n<br />\r\n<br />\r\n<br />\r\n<br />\r\n<p class="code"><em>.horiznav a.newclass{<br /> background-image:url(../images/system/pdf_button.png)!important;<br /> background-repeat:no-repeat!important;<br /> background-position:95% center!important;<br />}</em></p>\r\n<br />\r\n<br />\r\n<p><img src="images/YJSGMMI/css-class.jpg" border="0" alt="css class" title="css class" style="border: 0; float: left; margin: 10px;" /></p>\r\n<br />\r\n<p>On a per menu item basis you can also add your own css classes to  menu   items. In this screenshot we have added a symbol to just the home  menu   item by adding the above style  to custom.css:</p>', '', 1, 0, 0, 7, '2011-01-29 13:49:06', 42, '', '2011-05-09 11:35:54', 42, 0, '0000-00-00 00:00:00', '2011-01-29 13:49:06', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 36, 0, 4, '', '', 1, 81, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(11, 44, 'Archived Article', 'archived-article', '', '<p>Vivamus porta eros et neque vulputate pretium. Viva mus vel velit metus, scelerisque molestie augue. Aliquam semper hendrerit velit, at convallis augue pel lentesque vel.Donec sed accumsan sem. Nunc feugiat elit eu nisi laci nia consequat. Mauris sed erat sit amet nibh aliquet Duis nisi sapien, feugiat tem</p>\r\n', '\r\n<p>Vivamus porta eros et neque vulputate pretium. Viva mus vel velit metus, scelerisque molestie augue. Aliquam semper hendrerit velit, at convallis augue pel lentesque vel.Donec sed accumsan sem. Nunc feugiat elit eu nisi laci nia consequat. Mauris sed erat sit amet nibh aliquet Duis nisi sapien, feugiat tem</p>\r\n<br />', 2, 0, 0, 2, '2011-01-29 15:42:27', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2011-01-29 15:42:27', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 0, '', '', 1, 2, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(12, 45, 'Typography', 'typography', '', '<h3>New Typography styles for your <strong>TEMPLATE-NAME</strong> Joomla Template!</h3>\r\n\r\nT<span class="dropcap">T</span>his is a Magazine Style Drop Cap. To display Drop Cap us &lt;p span class="dropcap"&gt;First Letter Goes Here&lt;/span&gt; Olypian quarrels et gorilla congolium sic ad nauseum. Souvlaki ignitus carborundum e pluribus unum. Defacto lingo est igpay atinlay. Marquee selectus non provisio incongruous feline nolo contendre. Gratuitous octopus niacin, sodium glutimate. Quote meon an estimate et non interruptus stadium. Sic tempus fugit esperanto hiccup estrogen. Glorious.\r\n<br />\r\n<br />\r\n<h1>Heading1 (h1) looks like this</h1>\r\n<p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex.</p>\r\n<br />\r\n\r\n<h2>Heading2 (h2) looks like this</h2>\r\n<p>Li Europan lingues es membres del sam familie. Lor separat existentie es un myth. Por scientie, musica, sport etc, li tot Europa usa li sam vocabularium. Li lingues differe solmen in li grammatica, li pronunciation e li plu commun vocabules. Omnicos.</p>\r\n<h3>Heading3 (h3) looks like this</h3>\r\n<p>Ma quande lingues coalesce, li grammatica del resultant lingue es plu simplic e regulari quam ti del coalescent lingues. Li nov lingua franca va esser plu simplic e regulari quam li existent Europan lingues. It va esser tam simplic quam Occidental:</p>\r\n<h4>Heading4 (h4) looks like this</h4>\r\n<p>Epsum factorial non deposit quid pro quo hic escorol. Olypian quarrels et gorilla congolium sic ad nauseum. Souvlaki ignitus carborundum e pluribus unum. Defacto lingo est igpay atinlay. Marquee selectus non provisio incongruous feline nolo contendre.</p>\r\n<br />\r\n<br />\r\n<p class="error">To display error message&lt;p class="error"&gt;Error message here!&lt;/p&gt;.</p>\r\n\r\n<p class="message">To display info message&lt;p class="massage"&gt;Info messag ehere!&lt;/p&gt;.</p>\r\n<p class="tips">To display tips message&lt;p class="tips"&gt;Info messagehere!&lt;/p&gt;.</p>\r\n<span class="highlight">To highlight phrase use</span>&lt;span class="highlight"&gt;This is sample of highlighted phrase!&lt;/span&gt;\r\n\r\n<br />\r\n<br />\r\n<p><strong>To display codes use </strong></p>\r\n<pre>&lt;pre&gt; or &lt;div class="code"&gt;</pre>\r\n<pre>&lt;?php$lijevo = mosCountModules( ''left'' );<br />if ( $lijevo ) {$maincontent = ''right_side'';} else {$maincontent = ''right_side_full'';?</pre>\r\n<p class="sticky">To display sticky note use: &lt;p class="sticky"&gt;Sample of your note!&lt;/p&gt;</p>\r\n\r\n<p class="pin">To display pin note use :&lt;p class="pin"&gt;Sample of your pin note !&lt;/p&gt;</p>\r\n<p class="clip">To display clip note use:&lt;p class="clip"&gt;Sample of your clip note&lt;/p&gt;</p>\r\n<p class="down">To display download note use:&lt;p class="down"&gt;Sample of your download  note&lt;/p&gt;</p>\r\n<div class="blockquote">\r\n<blockquote>\r\n\r\n<div></div>\r\n<div>To display blockquote note use: &lt;div class="blockquote"&gt;&lt;blockquote&gt;Sample of your blockquote note&lt;/blockquote&gt;&lt;/div&gt;</div>\r\n</blockquote>\r\n</div>\r\n<div>\r\n<p class="blocknumber"><span class="bignumber">01</span><strong>Sample of Big Numbers List</strong>&lt;p class="blocknumber"&gt;&lt;span class="bignumber"&gt;01.&lt;/span&gt;Content goes here!&lt;/p&gt;Need some more text here to display demo content.Need some more text here to display demo content.Need some more text here to display demo content.</p>\r\n\r\n<p class="blocknumber"><span class="bignumber">02</span><strong>Sample of Big Numbers List </strong>&lt;p class="blocknumber"&gt;&lt;span class="bignumber"&gt;02.&lt;/span&gt;Content goes here!&lt;/p&gt; Need some more text here to display demo content.Need some more text here to display demo content.Need some more text here to display demo content.</p>\r\n<p class="blocknumber"><span class="bignumber">03</span><strong>Sample of Big Numbers List</strong>&lt;p class="blocknumber"&gt;&lt;span class="bignumber"&gt;03.&lt;/span&gt;Content goes here!&lt;/p&gt; Need some more text here to display demo content.Need some more text here to display demo content.Need some more text here to display demo content.</p>\r\n\r\n<br />\r\n<strong>Sample of ordered list . </strong><ol>\r\n<li>Sample of ordered list </li>\r\n<li>Sample of ordered list </li>\r\n<li>Sample of ordered list </li>\r\n<li>Sample of ordered list </li>\r\n</ol></div>\r\n<p><strong>Sample of check list .To use</strong></p>\r\n<pre>&lt;ul&gt;&lt;li class="check"&gt;Your list item goes here!&lt;/li&gt;&lt;/ul&gt;</pre>\r\n\r\n<ul>\r\n<li class="check"> Sample of li list </li>\r\n<li class="check"> Dolor sit </li>\r\n<li class="check"> Consectetuer </li>\r\n<li class="check"> Adipiscing elit </li>\r\n<li class="check"> Diam</li>\r\n</ul>\r\n\r\n<p><strong>Sample of star list .To use</strong></p>\r\n<pre>&lt;ul&gt;&lt;li class="star"&gt;Your list item goes here!&lt;/li&gt;&lt;/ul&gt;</pre>\r\n<ul>\r\n<li class="star"> Sample of li list </li>\r\n<li class="star"> Dolor sit </li>\r\n<li class="star"> Consectetuer </li>\r\n\r\n<li class="star"> Adipiscing elit </li>\r\n<li class="star"> Diam</li>\r\n</ul>\r\n<p><strong>Sample of video list .To use</strong></p>\r\n<pre>&lt;ul&gt;&lt;li class="video"&gt;Your list item goes here!&lt;/li&gt;&lt;/ul&gt;</pre>\r\n<ul>\r\n<li class="video"> Sample of li list </li>\r\n\r\n<li class="video"> Dolor sit </li>\r\n<li class="video"> Consectetuer </li>\r\n<li class="video"> Adipiscing elit </li>\r\n<li class="video"> Diam</li>\r\n</ul>\r\n<p><strong>Sample of image border use</strong></p>\r\n<div class="code">\r\n<p>&lt;img src="http://sitename/image.jpg class="border" alt="" title=""&gt;</p>\r\n\r\n</div>\r\n<p><img class="border" src="images/stories/clock.jpg" border="0" height="112" width="150" /></p>\r\n', '', 1, 0, 0, 7, '2011-01-29 15:50:35', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2011-01-29 15:50:35', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 2, '', '', 1, 3, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(13, 46, 'YJSG Module Positions', 'yjsg-module-positions', '', '<p>YJSimpleGrid Framework comes with 51 build in module positions . <em><strong><a title="Adding new modules grid to YJSG Framework" href="http://www.joomla1.5.youjoomla.info/yougrids/yjsg-framework/adding-new-grid.html" target="_blank">Adding new module</a></strong></em> grids is a very simple process and within few seconds you can adjust the layout to your own liking. Each&nbsp; module positon is completely collapsible either by disabling module in module manager or by setting module size to 0 in template manager. Mainbody grid is completely flexible and can swithc sides by simply adjusting default mainbody layout in template manager. Logo width and height can also be adjusted in template manager or completely disabled.</p>\r\n\r\n<p><img style="display: block; margin-left: auto; margin-right: auto;" alt="yjsg_modulepoz" src="images/stories/yjsg_modulepoz.gif" height="1010" width="800" /></p>\r\n', '', 1, 0, 0, 7, '2011-01-29 16:12:44', 42, '', '2011-02-04 15:01:48', 42, 0, '0000-00-00 00:00:00', '2011-01-29 16:12:44', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 0, 1, '', '', 1, 11, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', '');

-- --------------------------------------------------------

--
-- Table structure for table `#__content_frontpage`
--

DROP TABLE IF EXISTS `#__content_frontpage`;
CREATE TABLE IF NOT EXISTS `#__content_frontpage` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`content_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `#__content_frontpage`
--

INSERT INTO `#__content_frontpage` (`content_id`, `ordering`) VALUES
(1, 1),
(2, 2),
(3, 3),
(4, 4),
(5, 5),
(6, 6),
(7, 7);

-- --------------------------------------------------------

--
-- Table structure for table `#__content_rating`
--

DROP TABLE IF EXISTS `#__content_rating`;
CREATE TABLE IF NOT EXISTS `#__content_rating` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `rating_sum` int(10) unsigned NOT NULL DEFAULT '0',
  `rating_count` int(10) unsigned NOT NULL DEFAULT '0',
  `lastip` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`content_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `#__core_log_searches`
--

DROP TABLE IF EXISTS `#__core_log_searches`;
CREATE TABLE IF NOT EXISTS `#__core_log_searches` (
  `search_term` varchar(128) NOT NULL DEFAULT '',
  `hits` int(10) unsigned NOT NULL DEFAULT '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `#__extensions`
--

DROP TABLE IF EXISTS `#__extensions`;
CREATE TABLE IF NOT EXISTS `#__extensions` (
  `extension_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `type` varchar(20) NOT NULL,
  `element` varchar(100) NOT NULL,
  `folder` varchar(100) NOT NULL,
  `client_id` tinyint(3) NOT NULL,
  `enabled` tinyint(3) NOT NULL DEFAULT '1',
  `access` int(10) unsigned DEFAULT NULL,
  `protected` tinyint(3) NOT NULL DEFAULT '0',
  `manifest_cache` text NOT NULL,
  `params` text NOT NULL,
  `custom_data` text NOT NULL,
  `system_data` text NOT NULL,
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) DEFAULT '0',
  `state` int(11) DEFAULT '0',
  PRIMARY KEY (`extension_id`),
  KEY `element_clientid` (`element`,`client_id`),
  KEY `element_folder_clientid` (`element`,`folder`,`client_id`),
  KEY `extension` (`type`,`element`,`folder`,`client_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=10007 ;

--
-- Dumping data for table `#__extensions`
--

INSERT INTO `#__extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES
(1, 'com_mailto', 'component', 'com_mailto', '', 0, 1, 1, 1, '{"legacy":false,"name":"com_mailto","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_MAILTO_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(2, 'com_wrapper', 'component', 'com_wrapper', '', 0, 1, 1, 1, '{"legacy":false,"name":"com_wrapper","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_WRAPPER_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(3, 'com_admin', 'component', 'com_admin', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_admin","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_ADMIN_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(4, 'com_banners', 'component', 'com_banners', '', 1, 1, 1, 0, '{"legacy":false,"name":"com_banners","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_BANNERS_XML_DESCRIPTION","group":""}', '{"purchase_type":"3","track_impressions":"0","track_clicks":"0","metakey_prefix":""}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(5, 'com_cache', 'component', 'com_cache', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_cache","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_CACHE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(6, 'com_categories', 'component', 'com_categories', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_categories","type":"component","creationDate":"December 2007","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_CATEGORIES_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(7, 'com_checkin', 'component', 'com_checkin', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_checkin","type":"component","creationDate":"Unknown","author":"Joomla! Project","copyright":"(C) 2005 - 2008 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_CHECKIN_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(8, 'com_contact', 'component', 'com_contact', '', 1, 1, 1, 0, '{"legacy":false,"name":"com_contact","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_CONTACT_XML_DESCRIPTION","group":""}', '{"show_contact_category":"hide","show_contact_list":"0","presentation_style":"sliders","show_name":"1","show_position":"1","show_email":"0","show_street_address":"1","show_suburb":"1","show_state":"1","show_postcode":"1","show_country":"1","show_telephone":"1","show_mobile":"1","show_fax":"1","show_webpage":"1","show_misc":"1","show_image":"1","image":"","allow_vcard":"0","show_articles":"0","show_profile":"0","show_links":"0","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","contact_icons":"0","icon_address":"","icon_email":"","icon_telephone":"","icon_mobile":"","icon_fax":"","icon_misc":"","show_headings":"1","show_position_headings":"1","show_email_headings":"0","show_telephone_headings":"1","show_mobile_headings":"0","show_fax_headings":"0","allow_vcard_headings":"0","show_suburb_headings":"1","show_state_headings":"1","show_country_headings":"1","show_email_form":"1","show_email_copy":"1","banned_email":"","banned_subject":"","banned_text":"","validate_session":"1","custom_reply":"0","redirect":"","show_category_crumb":"0","metakey":"","metadesc":"","robots":"","author":"","rights":"","xreference":""}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(9, 'com_cpanel', 'component', 'com_cpanel', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_cpanel","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_CPANEL_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10, 'com_installer', 'component', 'com_installer', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_installer","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_INSTALLER_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(11, 'com_languages', 'component', 'com_languages', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_languages","type":"component","creationDate":"2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_LANGUAGES_XML_DESCRIPTION","group":""}', '{"administrator":"en-GB","site":"en-GB"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(12, 'com_login', 'component', 'com_login', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_login","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_LOGIN_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(13, 'com_media', 'component', 'com_media', '', 1, 1, 0, 1, '{"legacy":false,"name":"com_media","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_MEDIA_XML_DESCRIPTION","group":""}', '{"upload_extensions":"bmp,csv,doc,gif,ico,jpg,jpeg,odg,odp,ods,odt,pdf,png,ppt,swf,txt,xcf,xls,BMP,CSV,DOC,GIF,ICO,JPG,JPEG,ODG,ODP,ODS,ODT,PDF,PNG,PPT,SWF,TXT,XCF,XLS","upload_maxsize":"10","file_path":"images","image_path":"images","restrict_uploads":"1","allowed_media_usergroup":"3","check_mime":"1","image_extensions":"bmp,gif,jpg,png","ignore_extensions":"","upload_mime":"image\\/jpeg,image\\/gif,image\\/png,image\\/bmp,application\\/x-shockwave-flash,application\\/msword,application\\/excel,application\\/pdf,application\\/powerpoint,text\\/plain,application\\/x-zip","upload_mime_illegal":"text\\/html","enable_flash":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(14, 'com_menus', 'component', 'com_menus', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_menus","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_MENUS_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(15, 'com_messages', 'component', 'com_messages', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_messages","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_MESSAGES_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(16, 'com_modules', 'component', 'com_modules', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_modules","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_MODULES_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(17, 'com_newsfeeds', 'component', 'com_newsfeeds', '', 1, 1, 1, 0, '{"legacy":false,"name":"com_newsfeeds","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_NEWSFEEDS_XML_DESCRIPTION","group":""}', '{"show_feed_image":"1","show_feed_description":"1","show_item_description":"1","feed_word_count":"0","show_headings":"1","show_name":"1","show_articles":"0","show_link":"1","show_description":"1","show_description_image":"1","display_num":"","show_pagination_limit":"1","show_pagination":"1","show_pagination_results":"1","show_cat_items":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(18, 'com_plugins', 'component', 'com_plugins', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_plugins","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_PLUGINS_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(19, 'com_search', 'component', 'com_search', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_search","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_SEARCH_XML_DESCRIPTION","group":""}', '{"enabled":"0","show_date":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(20, 'com_templates', 'component', 'com_templates', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_templates","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_TEMPLATES_XML_DESCRIPTION","group":""}', '{"template_positions_display":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(21, 'com_weblinks', 'component', 'com_weblinks', '', 1, 1, 1, 0, '{"legacy":false,"name":"com_weblinks","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_WEBLINKS_XML_DESCRIPTION","group":""}', '{"show_comp_description":"1","comp_description":"","show_link_hits":"1","show_link_description":"1","show_other_cats":"0","show_headings":"0","show_numbers":"0","show_report":"1","count_clicks":"1","target":"0","link_icons":""}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(22, 'com_content', 'component', 'com_content', '', 1, 1, 0, 1, '{"legacy":false,"name":"com_content","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_CONTENT_XML_DESCRIPTION","group":""}', '{"article_layout":"_:default","show_title":"1","link_titles":"1","show_intro":"1","show_category":"1","link_category":"1","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"0","show_create_date":"0","show_modify_date":"0","show_publish_date":"1","show_item_navigation":"1","show_vote":"0","show_readmore":"1","show_readmore_title":"1","readmore_limit":"100","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"1","show_noauth":"0","urls_position":"0","show_publishing_options":"1","show_article_options":"1","show_urls_images_frontend":"1","show_urls_images_backend":"1","targeta":0,"targetb":0,"targetc":0,"float_intro":"right","float_fulltext":"right","category_layout":"_:blog","show_category_title":"0","show_description":"0","show_description_image":"0","maxLevel":"1","show_empty_categories":"0","show_no_articles":"1","show_subcat_desc":"1","show_cat_num_articles":"0","show_base_description":"1","maxLevelcat":"-1","show_empty_categories_cat":"0","show_subcat_desc_cat":"1","show_cat_num_articles_cat":"1","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"0","show_subcategory_content":"0","show_pagination_limit":"1","filter_field":"hide","show_headings":"1","list_show_date":"0","date_format":"","list_show_hits":"1","list_show_author":"1","orderby_pri":"order","orderby_sec":"rdate","order_date":"published","show_pagination":"2","show_pagination_results":"1","show_feed_link":"1","feed_summary":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(23, 'com_config', 'component', 'com_config', '', 1, 1, 0, 1, '{"legacy":false,"name":"com_config","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_CONFIG_XML_DESCRIPTION","group":""}', '{"filters":{"1":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"6":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"7":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"2":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"3":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"4":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"5":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"10":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"12":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"8":{"filter_type":"BL","filter_tags":"","filter_attributes":""}}}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(24, 'com_redirect', 'component', 'com_redirect', '', 1, 1, 0, 1, '{"legacy":false,"name":"com_redirect","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_REDIRECT_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(25, 'com_users', 'component', 'com_users', '', 1, 1, 0, 1, '{"legacy":false,"name":"com_users","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"COM_USERS_XML_DESCRIPTION","group":""}', '{"allowUserRegistration":"1","new_usertype":"2","useractivation":"1","frontend_userparams":"1","mailSubjectPrefix":"","mailBodySuffix":""}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(100, 'PHPMailer', 'library', 'phpmailer', '', 0, 1, 1, 1, '{"legacy":false,"name":"PHPMailer","type":"library","creationDate":"2008","author":"PHPMailer","copyright":"Copyright (C) PHPMailer.","authorEmail":"","authorUrl":"http:\\/\\/phpmailer.codeworxtech.com\\/","version":"2.5.0","description":"LIB_PHPMAILER_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(101, 'SimplePie', 'library', 'simplepie', '', 0, 1, 1, 1, '{"legacy":false,"name":"SimplePie","type":"library","creationDate":"2008","author":"SimplePie","copyright":"Copyright (C) 2008 SimplePie","authorEmail":"","authorUrl":"http:\\/\\/simplepie.org\\/","version":"1.0.1","description":"LIB_SIMPLEPIE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(102, 'phputf8', 'library', 'phputf8', '', 0, 1, 1, 1, '{"legacy":false,"name":"phputf8","type":"library","creationDate":"2008","author":"Harry Fuecks","copyright":"Copyright various authors","authorEmail":"","authorUrl":"http:\\/\\/sourceforge.net\\/projects\\/phputf8","version":"2.5.0","description":"LIB_PHPUTF8_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(103, 'Joomla! Web Application Framework', 'library', 'joomla', '', 0, 1, 1, 0, '{"legacy":false,"name":"Joomla! Web Application Framework","type":"library","creationDate":"2008","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"http:\\/\\/www.joomla.org","version":"2.5.0","description":"LIB_JOOMLA_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(200, 'mod_articles_archive', 'module', 'mod_articles_archive', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_articles_archive","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters.\\n\\t\\tAll rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_ARTICLES_ARCHIVE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(201, 'mod_articles_latest', 'module', 'mod_articles_latest', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_articles_latest","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_LATEST_NEWS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(202, 'mod_articles_popular', 'module', 'mod_articles_popular', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_articles_popular","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_POPULAR_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(203, 'mod_banners', 'module', 'mod_banners', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_banners","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_BANNERS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(204, 'mod_breadcrumbs', 'module', 'mod_breadcrumbs', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_breadcrumbs","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_BREADCRUMBS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(205, 'mod_custom', 'module', 'mod_custom', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_custom","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_CUSTOM_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(206, 'mod_feed', 'module', 'mod_feed', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_feed","type":"module","creationDate":"July 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_FEED_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(207, 'mod_footer', 'module', 'mod_footer', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_footer","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_FOOTER_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(208, 'mod_login', 'module', 'mod_login', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_login","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_LOGIN_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(209, 'mod_menu', 'module', 'mod_menu', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_menu","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_MENU_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(210, 'mod_articles_news', 'module', 'mod_articles_news', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_articles_news","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_ARTICLES_NEWS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(211, 'mod_random_image', 'module', 'mod_random_image', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_random_image","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_RANDOM_IMAGE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(212, 'mod_related_items', 'module', 'mod_related_items', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_related_items","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_RELATED_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(213, 'mod_search', 'module', 'mod_search', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_search","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_SEARCH_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(214, 'mod_stats', 'module', 'mod_stats', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_stats","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_STATS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(215, 'mod_syndicate', 'module', 'mod_syndicate', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_syndicate","type":"module","creationDate":"May 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_SYNDICATE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(216, 'mod_users_latest', 'module', 'mod_users_latest', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_users_latest","type":"module","creationDate":"December 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_USERS_LATEST_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(217, 'mod_weblinks', 'module', 'mod_weblinks', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_weblinks","type":"module","creationDate":"July 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_WEBLINKS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(218, 'mod_whosonline', 'module', 'mod_whosonline', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_whosonline","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_WHOSONLINE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(219, 'mod_wrapper', 'module', 'mod_wrapper', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_wrapper","type":"module","creationDate":"October 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_WRAPPER_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(220, 'mod_articles_category', 'module', 'mod_articles_category', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_articles_category","type":"module","creationDate":"February 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_ARTICLES_CATEGORY_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(221, 'mod_articles_categories', 'module', 'mod_articles_categories', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_articles_categories","type":"module","creationDate":"February 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_ARTICLES_CATEGORIES_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(222, 'mod_languages', 'module', 'mod_languages', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_languages","type":"module","creationDate":"February 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_LANGUAGES_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(300, 'mod_custom', 'module', 'mod_custom', '', 1, 1, 1, 1, '{"legacy":false,"name":"mod_custom","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_CUSTOM_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(301, 'mod_feed', 'module', 'mod_feed', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_feed","type":"module","creationDate":"July 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_FEED_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(302, 'mod_latest', 'module', 'mod_latest', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_latest","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_LATEST_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(303, 'mod_logged', 'module', 'mod_logged', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_logged","type":"module","creationDate":"January 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_LOGGED_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(304, 'mod_login', 'module', 'mod_login', '', 1, 1, 1, 1, '{"legacy":false,"name":"mod_login","type":"module","creationDate":"March 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_LOGIN_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(305, 'mod_menu', 'module', 'mod_menu', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_menu","type":"module","creationDate":"March 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_MENU_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(306, 'mod_online', 'module', 'mod_online', '', 1, 1, 1, 0, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(307, 'mod_popular', 'module', 'mod_popular', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_popular","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_POPULAR_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(308, 'mod_quickicon', 'module', 'mod_quickicon', '', 1, 1, 1, 1, '{"legacy":false,"name":"mod_quickicon","type":"module","creationDate":"Nov 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_QUICKICON_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(309, 'mod_status', 'module', 'mod_status', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_status","type":"module","creationDate":"Feb 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_STATUS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(310, 'mod_submenu', 'module', 'mod_submenu', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_submenu","type":"module","creationDate":"Feb 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_SUBMENU_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(311, 'mod_title', 'module', 'mod_title', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_title","type":"module","creationDate":"Nov 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_TITLE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(312, 'mod_toolbar', 'module', 'mod_toolbar', '', 1, 1, 1, 1, '{"legacy":false,"name":"mod_toolbar","type":"module","creationDate":"Nov 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"MOD_TOOLBAR_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(313, 'mod_multilangstatus', 'module', 'mod_multilangstatus', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_multilangstatus","type":"module","creationDate":"September 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.1","description":"MOD_MULTILANGSTATUS_XML_DESCRIPTION","group":""}', '{"cache":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(400, 'plg_authentication_gmail', 'plugin', 'gmail', 'authentication', 0, 0, 1, 0, '{"legacy":false,"name":"plg_authentication_gmail","type":"plugin","creationDate":"February 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_GMAIL_XML_DESCRIPTION","group":""}', '{"applysuffix":"0","suffix":"","verifypeer":"1","user_blacklist":""}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(401, 'plg_authentication_joomla', 'plugin', 'joomla', 'authentication', 0, 1, 1, 1, '{"legacy":false,"name":"plg_authentication_joomla","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_AUTH_JOOMLA_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(402, 'plg_authentication_ldap', 'plugin', 'ldap', 'authentication', 0, 0, 1, 0, '{"legacy":false,"name":"plg_authentication_ldap","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_LDAP_XML_DESCRIPTION","group":""}', '{"host":"","port":"389","use_ldapV3":"0","negotiate_tls":"0","no_referrals":"0","auth_method":"bind","base_dn":"","search_string":"","users_dn":"","username":"admin","password":"bobby7","ldap_fullname":"fullName","ldap_email":"mail","ldap_uid":"uid"}', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(404, 'plg_content_emailcloak', 'plugin', 'emailcloak', 'content', 0, 1, 1, 0, '{"legacy":false,"name":"plg_content_emailcloak","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_CONTENT_EMAILCLOAK_XML_DESCRIPTION","group":""}', '{"mode":"1"}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(405, 'plg_content_geshi', 'plugin', 'geshi', 'content', 0, 0, 1, 0, '{"legacy":false,"name":"plg_content_geshi","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"","authorUrl":"qbnz.com\\/highlighter","version":"2.5.0","description":"PLG_CONTENT_GESHI_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(406, 'plg_content_loadmodule', 'plugin', 'loadmodule', 'content', 0, 1, 1, 0, '{"legacy":false,"name":"plg_content_loadmodule","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_LOADMODULE_XML_DESCRIPTION","group":""}', '{"style":"none"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(407, 'plg_content_pagebreak', 'plugin', 'pagebreak', 'content', 0, 1, 1, 1, '{"legacy":false,"name":"plg_content_pagebreak","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_CONTENT_PAGEBREAK_XML_DESCRIPTION","group":""}', '{"title":"1","multipage_toc":"1","showall":"1"}', '', '', 0, '0000-00-00 00:00:00', 4, 0),
(408, 'plg_content_pagenavigation', 'plugin', 'pagenavigation', 'content', 0, 1, 1, 1, '{"legacy":false,"name":"plg_content_pagenavigation","type":"plugin","creationDate":"January 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_PAGENAVIGATION_XML_DESCRIPTION","group":""}', '{"position":"1"}', '', '', 0, '0000-00-00 00:00:00', 5, 0),
(409, 'plg_content_vote', 'plugin', 'vote', 'content', 0, 1, 1, 1, '{"legacy":false,"name":"plg_content_vote","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_VOTE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 6, 0),
(410, 'plg_editors_codemirror', 'plugin', 'codemirror', 'editors', 0, 1, 1, 1, '{"legacy":false,"name":"plg_editors_codemirror","type":"plugin","creationDate":"28 March 2011","author":"Marijn Haverbeke","copyright":"","authorEmail":"N\\/A","authorUrl":"","version":"1.0","description":"PLG_CODEMIRROR_XML_DESCRIPTION","group":""}', '{"linenumbers":"0","tabmode":"indent"}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(411, 'plg_editors_none', 'plugin', 'none', 'editors', 0, 1, 1, 1, '{"legacy":false,"name":"plg_editors_none","type":"plugin","creationDate":"August 2004","author":"Unknown","copyright":"","authorEmail":"N\\/A","authorUrl":"","version":"2.5.0","description":"PLG_NONE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(412, 'plg_editors_tinymce', 'plugin', 'tinymce', 'editors', 0, 1, 1, 1, '{"legacy":false,"name":"plg_editors_tinymce","type":"plugin","creationDate":"2005-2011","author":"Moxiecode Systems AB","copyright":"Moxiecode Systems AB","authorEmail":"N\\/A","authorUrl":"tinymce.moxiecode.com\\/","version":"3.4.7","description":"PLG_TINY_XML_DESCRIPTION","group":""}', '{"mode":"1","skin":"0","compressed":"0","cleanup_startup":"0","cleanup_save":"2","entity_encoding":"raw","lang_mode":"0","lang_code":"en","text_direction":"ltr","content_css":"1","content_css_custom":"","relative_urls":"1","newlines":"0","invalid_elements":"script,applet,iframe","extended_elements":"","toolbar":"top","toolbar_align":"left","html_height":"550","html_width":"750","element_path":"1","fonts":"1","paste":"1","searchreplace":"1","insertdate":"1","format_date":"%Y-%m-%d","inserttime":"1","format_time":"%H:%M:%S","colors":"1","table":"1","smilies":"1","media":"1","hr":"1","directionality":"1","fullscreen":"1","style":"1","layer":"1","xhtmlxtras":"1","visualchars":"1","nonbreaking":"1","template":"1","blockquote":"1","wordcount":"1","advimage":"1","advlink":"1","autosave":"1","contextmenu":"1","inlinepopups":"1","safari":"0","custom_plugin":"","custom_button":""}', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(413, 'plg_editors-xtd_article', 'plugin', 'article', 'editors-xtd', 0, 1, 1, 1, '{"legacy":false,"name":"plg_editors-xtd_article","type":"plugin","creationDate":"October 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_ARTICLE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(414, 'plg_editors-xtd_image', 'plugin', 'image', 'editors-xtd', 0, 1, 1, 0, '{"legacy":false,"name":"plg_editors-xtd_image","type":"plugin","creationDate":"August 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_IMAGE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(415, 'plg_editors-xtd_pagebreak', 'plugin', 'pagebreak', 'editors-xtd', 0, 1, 1, 0, '{"legacy":false,"name":"plg_editors-xtd_pagebreak","type":"plugin","creationDate":"August 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_EDITORSXTD_PAGEBREAK_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(416, 'plg_editors-xtd_readmore', 'plugin', 'readmore', 'editors-xtd', 0, 1, 1, 0, '{"legacy":false,"name":"plg_editors-xtd_readmore","type":"plugin","creationDate":"March 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_READMORE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 4, 0),
(417, 'plg_search_categories', 'plugin', 'categories', 'search', 0, 1, 1, 0, '{"legacy":false,"name":"plg_search_categories","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_SEARCH_CATEGORIES_XML_DESCRIPTION","group":""}', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(418, 'plg_search_contacts', 'plugin', 'contacts', 'search', 0, 1, 1, 0, '{"legacy":false,"name":"plg_search_contacts","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_SEARCH_CONTACTS_XML_DESCRIPTION","group":""}', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(419, 'plg_search_content', 'plugin', 'content', 'search', 0, 1, 1, 0, '{"legacy":false,"name":"plg_search_content","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_SEARCH_CONTENT_XML_DESCRIPTION","group":""}', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(420, 'plg_search_newsfeeds', 'plugin', 'newsfeeds', 'search', 0, 1, 1, 0, '{"legacy":false,"name":"plg_search_newsfeeds","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_SEARCH_NEWSFEEDS_XML_DESCRIPTION","group":""}', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(421, 'plg_search_weblinks', 'plugin', 'weblinks', 'search', 0, 1, 1, 0, '{"legacy":false,"name":"plg_search_weblinks","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_SEARCH_WEBLINKS_XML_DESCRIPTION","group":""}', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(422, 'plg_system_languagefilter', 'plugin', 'languagefilter', 'system', 0, 0, 1, 1, '{"legacy":false,"name":"plg_system_languagefilter","type":"plugin","creationDate":"July 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_SYSTEM_LANGUAGEFILTER_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(423, 'plg_system_p3p', 'plugin', 'p3p', 'system', 0, 1, 1, 1, '{"legacy":false,"name":"plg_system_p3p","type":"plugin","creationDate":"September 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_P3P_XML_DESCRIPTION","group":""}', '{"headers":"NOI ADM DEV PSAi COM NAV OUR OTRo STP IND DEM"}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(424, 'plg_system_cache', 'plugin', 'cache', 'system', 0, 0, 1, 1, '{"legacy":false,"name":"plg_system_cache","type":"plugin","creationDate":"February 2007","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_CACHE_XML_DESCRIPTION","group":""}', '{"browsercache":"0","cachetime":"15"}', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(425, 'plg_system_debug', 'plugin', 'debug', 'system', 0, 1, 1, 0, '{"legacy":false,"name":"plg_system_debug","type":"plugin","creationDate":"December 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_DEBUG_XML_DESCRIPTION","group":""}', '{"profile":"1","queries":"1","memory":"1","language_files":"1","language_strings":"1","strip-first":"1","strip-prefix":"","strip-suffix":""}', '', '', 0, '0000-00-00 00:00:00', 4, 0),
(426, 'plg_system_log', 'plugin', 'log', 'system', 0, 1, 1, 1, '{"legacy":false,"name":"plg_system_log","type":"plugin","creationDate":"April 2007","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_LOG_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 5, 0),
(427, 'plg_system_redirect', 'plugin', 'redirect', 'system', 0, 1, 1, 1, '{"legacy":false,"name":"plg_system_redirect","type":"plugin","creationDate":"April 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_REDIRECT_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 6, 0),
(428, 'plg_system_remember', 'plugin', 'remember', 'system', 0, 1, 1, 1, '{"legacy":false,"name":"plg_system_remember","type":"plugin","creationDate":"April 2007","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_REMEMBER_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 7, 0),
(429, 'plg_system_sef', 'plugin', 'sef', 'system', 0, 1, 1, 0, '{"legacy":false,"name":"plg_system_sef","type":"plugin","creationDate":"December 2007","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_SEF_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 8, 0),
(430, 'plg_system_logout', 'plugin', 'logout', 'system', 0, 1, 1, 1, '{"legacy":false,"name":"plg_system_logout","type":"plugin","creationDate":"April 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_SYSTEM_LOGOUT_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 9, 0),
(431, 'plg_user_contactcreator', 'plugin', 'contactcreator', 'user', 0, 0, 1, 1, '{"legacy":false,"name":"plg_user_contactcreator","type":"plugin","creationDate":"August 2009","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_CONTACTCREATOR_XML_DESCRIPTION","group":""}', '{"autowebpage":"","category":"34","autopublish":"0"}', '', '', 0, '0000-00-00 00:00:00', 1, 0);
INSERT INTO `#__extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES
(432, 'plg_user_joomla', 'plugin', 'joomla', 'user', 0, 1, 1, 0, '{"legacy":false,"name":"plg_user_joomla","type":"plugin","creationDate":"December 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2009 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_USER_JOOMLA_XML_DESCRIPTION","group":""}', '{"autoregister":"1"}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(433, 'plg_user_profile', 'plugin', 'profile', 'user', 0, 0, 1, 1, '{"legacy":false,"name":"plg_user_profile","type":"plugin","creationDate":"January 2008","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_USER_PROFILE_XML_DESCRIPTION","group":""}', '{"register-require_address1":"1","register-require_address2":"1","register-require_city":"1","register-require_region":"1","register-require_country":"1","register-require_postal_code":"1","register-require_phone":"1","register-require_website":"1","register-require_favoritebook":"1","register-require_aboutme":"1","register-require_tos":"1","register-require_dob":"1","profile-require_address1":"1","profile-require_address2":"1","profile-require_city":"1","profile-require_region":"1","profile-require_country":"1","profile-require_postal_code":"1","profile-require_phone":"1","profile-require_website":"1","profile-require_favoritebook":"1","profile-require_aboutme":"1","profile-require_tos":"1","profile-require_dob":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(434, 'plg_extension_joomla', 'plugin', 'joomla', 'extension', 0, 1, 1, 1, '{"legacy":false,"name":"plg_extension_joomla","type":"plugin","creationDate":"May 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_EXTENSION_JOOMLA_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(435, 'plg_content_joomla', 'plugin', 'joomla', 'content', 0, 1, 1, 0, '{"legacy":false,"name":"plg_content_joomla","type":"plugin","creationDate":"November 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_CONTENT_JOOMLA_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(500, 'atomic', 'template', 'atomic', '', 0, 1, 1, 0, '{"legacy":false,"name":"atomic","type":"template","creationDate":"10\\/10\\/09","author":"Ron Severdia","copyright":"Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.","authorEmail":"contact@kontentdesign.com","authorUrl":"http:\\/\\/www.kontentdesign.com","version":"2.5.0","description":"TPL_ATOMIC_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(502, 'bluestork', 'template', 'bluestork', '', 1, 1, 1, 0, '{"legacy":false,"name":"bluestork","type":"template","creationDate":"07\\/02\\/09","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"TPL_BLUESTORK_XML_DESCRIPTION","group":""}', '{"useRoundedCorners":"1","showSiteName":"0","textBig":"0","highContrast":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(503, 'beez_20', 'template', 'beez_20', '', 0, 1, 1, 0, '{"legacy":false,"name":"beez_20","type":"template","creationDate":"25 November 2009","author":"Angie Radtke","copyright":"Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.","authorEmail":"a.radtke@derauftritt.de","authorUrl":"http:\\/\\/www.der-auftritt.de","version":"2.5.0","description":"TPL_BEEZ2_XML_DESCRIPTION","group":""}', '{"wrapperSmall":"53","wrapperLarge":"72","sitetitle":"","sitedescription":"","navposition":"center","templatecolor":"nature"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(504, 'hathor', 'template', 'hathor', '', 1, 1, 1, 0, '{"legacy":false,"name":"hathor","type":"template","creationDate":"May 2010","author":"Andrea Tarr","copyright":"Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.","authorEmail":"hathor@tarrconsulting.com","authorUrl":"http:\\/\\/www.tarrconsulting.com","version":"2.5.0","description":"TPL_HATHOR_XML_DESCRIPTION","group":""}', '{"showSiteName":"0","colourChoice":"0","boldText":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(505, 'beez5', 'template', 'beez5', '', 0, 1, 1, 0, '{"legacy":false,"name":"beez5","type":"template","creationDate":"21 May 2010","author":"Angie Radtke","copyright":"Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.","authorEmail":"a.radtke@derauftritt.de","authorUrl":"http:\\/\\/www.der-auftritt.de","version":"2.5.0","description":"TPL_BEEZ5_XML_DESCRIPTION","group":""}', '{"wrapperSmall":"53","wrapperLarge":"72","sitetitle":"","sitedescription":"","navposition":"center","html5":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(600, 'English (United Kingdom)', 'language', 'en-GB', '', 0, 1, 1, 1, '{"legacy":false,"name":"English (United Kingdom)","type":"language","creationDate":"2008-03-15","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"en-GB site language","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(601, 'English (United Kingdom)', 'language', 'en-GB', '', 1, 1, 1, 1, '{"legacy":false,"name":"English (United Kingdom)","type":"language","creationDate":"2008-03-15","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"en-GB administrator language","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(700, 'files_joomla', 'file', 'joomla', '', 0, 1, 1, 1, '{"legacy":false,"name":"files_joomla","type":"file","creationDate":"January 2012","author":"Joomla! Project","copyright":"(C) 2005 - 2012 Open Source Matters. All rights reserved","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"FILES_JOOMLA_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10001, 'System - YJMegaMenu', 'plugin', 'YJMegaMenu', 'system', 0, 1, 1, 0, '{"legacy":false,"name":"System - YJMegaMenu","type":"plugin","creationDate":"January 2011","author":"YouJoomla LLC","copyright":"Copyright (C) 2007 - 2011 Youjoomla LLC. All rights reserved.","authorEmail":"youjoomlallc@gmail.com","authorUrl":"www.www.youjoomla.com","version":"1.6","description":"Provides YJMegaMenu Parameters Tab in MainMenu Administration!","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10002, 'Youdesigns', 'template', 'youdesigns', '', 0, 1, 1, 0, '{"legacy":true,"name":"Youdesigns","type":"template","creationDate":"5-8-2011","author":"Youjoomla LLC","copyright":"Youjoomla LLC","authorEmail":"youjoomlallc@gmail.com","authorUrl":"www.youjoomla.com","version":"1.0","description":"\\n\\t\\t<div id=\\"temp_desc\\"><h1 class=\\"admin_t_name\\">YouDesigns Joomla! Template<\\/h1>\\n\\t\\t\\t<img src=\\"..\\/templates\\/youdesigns\\/template_thumbnail.png\\" \\/><br \\/><br \\/>\\n\\t\\t\\t<h1 class=\\"admin_t_name\\">is proudly powered by<\\/h1>\\n\\t\\t\\t<a href=\\"http:\\/\\/www.yjsimplegrid.com\\" class=\\"modal\\" rel=\\"{handler: ''iframe'', size: {x: 800, y: 700}}\\">\\n\\t\\t\\t<span title=\\"YJSimpleGrid Joomla! Template Framework by Youjoomla.com\\">\\n\\t\\t\\t<img src=\\"..\\/templates\\/youdesigns\\/images\\/admin\\/yjsgadmin_logo.png\\" border=\\"0\\" title=\\"\\" alt=\\"\\"\\/>\\n\\t\\t\\t<\\/span>\\n\\t\\t\\t<\\/a>\\n\\t\\t\\t\\n\\t\\t\\t<div id=\\"temp_det\\">      \\n\\t\\t\\t<h3>Version 1.0.11 Initial Release<\\/h3>\\n\\t\\t\\t\\n\\t\\t\\t<p>YouDesigns Joomla  Template by Youjoomla.com. This is Commercial  Template by Youjoomla.com. Visit <a href=\\"http:\\/\\/www.youjoomla.com\\">Youjoomla \\t\\t\\tTemlplates Club<\\/a> home page.\\n\\t\\t\\t<\\/p>\\n\\t\\t\\t<h3>Some of the YJSimpleGrid Template Framework Features are:<\\/h3>\\n\\t\\t\\t<ul>\\n\\t\\t\\t<li>Advanced Joomla Template Manager Admin Panel<\\/li>\\n\\t\\t\\t<li>Flexible Layouts<\\/li>\\n\\t\\t\\t<li>Over 52 collapsible module positions easily add more<\\/li>\\n\\t\\t\\t<li>Automatic module width adjustment in template manager<\\/li>\\n\\t\\t\\t<li>Native RTL<\\/li>\\n\\t\\t\\t<li>Native Mobile devices support<\\/li>\\n\\t\\t\\t<li>Custom iPhone\\/iPad\\/iPod and handheld devices template<\\/li>\\n\\t\\t\\t<li>Cross browser support<\\/li>\\n\\t\\t\\t<li>Native Cufon and Google Font plus 15 CSS font styles<\\/li>\\n\\t\\t\\t<li>Native Jquery Support<\\/li>\\n\\t\\t\\t<li>Google Analytics website tracking built in<\\/li>\\n\\t\\t\\t<li>Native rounded and square module styles 1 click switch<\\/li>\\n\\t\\t\\t<li>1 image PNG transparent rounded corners approach for easy editing<\\/li>\\n\\t\\t\\t<li>Component off switch or menu item assignment<\\/li>\\n\\t\\t\\t<li>Topmenu off switch or menu item assignment<\\/li>\\n\\t\\t\\t<li>7 default module grids with 5 modules each. Easily add more<\\/li>\\n\\t\\t\\t<li>Flexible logo and header size changer<\\/li>\\n\\t\\t\\t<li>Upgraded server side compression<\\/li>\\n\\t\\t\\t<li>Frontpage news items number of  characters control<\\/li>\\n\\t\\t\\t<li>Visible RTL switch and Font resizer<\\/li>\\n\\t\\t\\t<li>5 menu styles<\\/li>\\n\\t\\t\\t<li>Show page title under menu link<\\/li>\\n\\t\\t\\t<li>Custom error and offline pages<\\/li>\\n\\t\\t\\t<li>Custom user pages ( com_user )<\\/li>\\n\\t\\t\\t<li>Slide to top smothscroll<\\/li>\\n\\t\\t\\t<li>XHTML , CSS and JS valid<\\/li>\\n\\t\\t\\t<\\/ul>\\n\\t\\t\\t<h3>For additional documentation please visit <a href=\\"http:\\/\\/www.yjsimplegrid.com\\" target=\\"_blank\\">YJSimpleGrid<\\/a><\\/h3>\\n\\t\\t\\t\\n\\t\\t\\t<\\/div>\\n\\t\\t\\t<\\/div>\\n\\t","group":""}', '{"":"HEAD_DIS_TXT","STYLE_SETTINGS_TAB":"STYLE_SETTINGS_TAB","custom_css":"2","STTEXT_LABEL":"STTEXT_LABEL","STYLE_SUB":"STYLE_SUB","default_color":"metal","default_font":"3","default_font_family":"6","selectors_override":"1","selectors_override_type":"3","css_font_family":"12","google_font_family":"2","cufon_font_family":"11","affected_selectors":"div.title h1,div.title h2,div.componentheading, h1,h2,h3,h4,h5,h6,.yjround h4,.yjsquare h4,span.stitle","LOGO_SUB":"LOGO_SUB","LGTEXT_LABEL":"LGTEXT_LABEL","LOGO_YJ_TITLE":"LOGO_YJ_TITLE","logo_height":"80px","logo_width":"250px","turn_logo_off":"2","turn_header_block_off":"2","call_us":"1","call_us_text":"Give Us a Call:012-345-678","TOP_MENU_SUB":"TOP_MENU_SUB","TMTEXT_LABEL":"TMTEXT_LABEL","TOP_MENU_YJ_LABEL":"TOP_MENU_YJ_LABEL","menuName":"mainmenu","default_menu_style":"2","sub_width":"280px","yjsg_menu_offset":"95","turn_topmenu_off":"0","DEF_GRID_SUB":"DEF_GRID_SUB","DGTEXT_LABEL":"DGTEXT_LABEL","MAINB_YJ_LABEL":"MAINB_YJ_LABEL","css_widthdefined":"px","css_width":"1000","site_layout":"2","MBC_W_LABEL":"MBC_W_LABEL","widthdefined":"%","maincolumn":"55","insetcolumn":"0","leftcolumn":"22.5","rightcolumn":"22.5","SPII_LABEL":"SPII_LABEL","widthdefined_itmid":"%","maincolumn_itmid":"55","insetcolumn_itmid":"0","leftcolumn_itmid":"22.5","rightcolumn_itmid":"22.5","define_itemid":"0","MG_SUB":"MG_SUB","MGTEXT_LABEL":"MGTEXT_LABEL","yjsg_1_width":"20|20|20|20|20","yjsg_2_width":"20|20|20|20|20","yjsg_3_width":"20|20|20|20|20","yjsg_4_width":"20|20|20|20|20","yjsg_bodytop_width":"33|33|33","yjsg_yjsgbodytbottom_width":"33|33|33","yjsg_5_width":"20|20|20|20|20","yjsg_6_width":"20|20|20|20|20","yjsg_7_width":"20|20|20|20|20","MOBILE_SUB":"MOBILE_SUB","MOBILE_TXT_LABEL":"MOBILE_TXT_LABEL","iphone_default":"1","android_default":"1","handheld_default":"2","mobile_reg":"1","ADD_F_SUB":"ADD_F_SUB","ADTEXT_LABEL":"ADTEXT_LABEL","GA_YJ_LABEL":"GA_YJ_LABEL","GATEXT_LABEL":"GATEXT_LABEL","ga_switch":"0","GAcode":"UA-xxxxxx-x","NOT_YJ_LABEL":"NOT_YJ_LABEL","compress":"0","ie6notice":"0","nonscript":"0","ST_YJ_LABEL":"ST_YJ_LABEL","show_tools":"1","show_fres":"1","show_rtlc":"1","TDIR_YJ_LABEL":"TDIR_YJ_LABEL","text_direction":"2","SEO_YJ_LABEL":"SEO_YJ_LABEL","turn_seo_off":"2","seo":"Your description goes here","tags":"Your keywords go here","COPY_YJ_LABEL":"COPY_YJ_LABEL","branding_off":"2","joomlacredit_off":"2","ADV_SUB":"ADV_SUB","ADVTEXT_LABEL":"ADVTEXT_LABEL","FPC_YJ_LABEL":"FPC_YJ_LABEL","fp_controll_switch":"2","fp_chars_limit":"3000","fp_after_text":"","SCRIPT_YJ_LABEL":"SCRIPT_YJ_LABEL","JQ_LABEL":"JQ_LABEL","jq_switch":"2","SMS_YJ_LABEL":"SMS_YJ_LABEL","MSTEXT_LABEL":"MSTEXT_LABEL","YJsg1_module_style":"YJsgxhtml","YJsgh_module_style":"YJsgxhtml","YJsg2_module_style":"YJsgxhtml","YJsg3_module_style":"YJsgxhtml","YJsg4_module_style":"YJsgxhtml","YJsgmt_module_style":"YJsgxhtml","YJsgl_module_style":"YJsgxhtml","YJsgr_module_style":"YJsgxhtml","YJsgi_module_style":"YJsgxhtml","YJsgit_module_style":"YJsgxhtml","YJsgib_module_style":"YJsgxhtml","YJsgmb_module_style":"YJsgxhtml","YJsg5_module_style":"YJsgxhtml","YJsg6_module_style":"YJsgxhtml","YJsg7_module_style":"YJsgxhtml","CP_LABEL":"CP_LABEL","component_switch":"0","admin_css_time":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10003, 'YJ Latest Tweets', 'module', 'mod_yj_twitter', '', 0, 1, 0, 0, '{"legacy":false,"name":"YJ Latest Tweets","type":"module","creationDate":"3-15-2011","author":"youjoomla","copyright":"Youjoomla","authorEmail":"youjoomla@gmail.com","authorUrl":"http:\\/\\/www.youjoomla.com","version":"1.0","description":"\\n\\t\\t<style type=\\"text\\/css\\" media=\\"all\\">#wrap1 {padding:0px 0px 4px 0px;}h1 {clear:both;font-family: Arial Narrow,sans-serif;font-size:18px;margin:0px 0px 12px 0px;padding:0px 0px 1px 10px;color:#C64934;}.wrap2 {background:#F7F7F7;}<\\/style><div id=\\"holdthem\\"><h1>YJ Latest Tweets Module ver 1.0 for Joomla 1.6x<\\/h1><div class=\\"wrap2\\"><a title=\\"Visit the official website!\\" href=\\"http:\\/\\/joomla1.5.youjoomla.info\\/youmedia\\"> <img style=\\"float:left;border:1px solid #CFCFCF;margin:0px 15px 4px 22px;\\" src=\\"..\\/modules\\/mod_yj_twitter\\/mod_yj_twitter\\/images\\/yj_extensions.jpg\\" border=\\"0\\" alt=\\"Logo\\" \\/><\\/a>\\n\\t","group":""}', '{"twitter_user":"","nr_article":"20","tweet_limit":"","tweet_link":"1","tweet_date":"1","tweet_follow":"1","tweet_image":"1","moduleclass_sfx":""}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10004, 'YJ Images Slider V3', 'module', 'mod_yjis3', '', 0, 1, 0, 0, '{"legacy":false,"name":"YJ Images Slider V3","type":"module","creationDate":"02-12-2011","author":"Youjoomla LLC","copyright":"","authorEmail":"youjoomla@gmail.com","authorUrl":"www.youjoomla.com","version":"1.6.0","description":"\\n\\t\\t<style type=\\"text\\/css\\" media=\\"all\\">#wrap1 {padding:0px 0px 4px 0px;}h1 {clear:both;font-family: Arial Narrow,sans-serif;font-size:18px;margin:0px 0px 12px 0px;padding:0px 0px 1px 10px;color:#C64934;}.wrap2 {background:#FAFAFA;}<\\/style><div id=\\"holdthem\\"><h1>YJ Images Slider   V3<\\/h1><br \\/><div class=\\"wrap2\\"><a title=\\"Visit the official website!\\" href=\\"http:\\/\\/www.youjoomla.com\\"> <img style=\\"float:left;border:0px;margin:0px 15px 4px 22px;\\"src=\\"..\\/modules\\/mod_yjis3\\/images\\/yj_extensions.jpg\\" border=\\"0\\" alt=\\"Logo\\" \\/><\\/a><br \\/> <h1> Please remember to upload images in site_root\\/images\\/upload_slides folder<\\/h1><br \\/> Instructions can be fund <a href=\\"http:\\/\\/www.joomla1.5.youjoomla.info\\/youfashion\\/index.php?option=com_content&view=article&id=50&Itemid=76\\" target=\\"_blank\\">here<\\/a><br \\/> List of available Multi media Box 3.0 video types  can be fund <a href=\\"http:\\/\\/joomla-16-templates.youjoomla.info\\/youevents\\/index.php?option=com_content&view=article&id=31&Itemid=211\\" target=\\"_blank\\">here<\\/a> \\n\\t","group":""}', '{"moduleclass_sfx":"_yjis","is_copy":"","swidth":"600","sheight":"250","sorient":"0","type_slider":"0","start_slide":"0","stime":"6000","sduration":"600","smenu":"0","pagination":"1","balons":"0","order":"0","slide_image_1":"","slide_title_1":"","slide_description_1":"","slide_intro_1":"","mbox_1":"0","mboxlink_1":"","mboxtype_1":"0","video_width_1":"640","video_height_1":"360","image_group_1":"0","image_group_name_1":"yjgallery","slide_link_1":"","slide_open_1":"0","slide_image_2":"","slide_title_2":"","slide_description_2":"","slide_intro_2":"","mbox_2":"0","mboxlink_2":"","mboxtype_2":"0","video_width_2":"640","video_height_2":"360","image_group_2":"0","image_group_name_2":"yjgallery","slide_link_2":"","slide_open_2":"0","slide_image_3":"","slide_title_3":"","slide_description_3":"","slide_intro_3":"","mbox_3":"0","mboxlink_3":"","mboxtype_3":"0","video_width_3":"640","video_height_3":"360","image_group_3":"0","image_group_name_3":"yjgallery","slide_link_3":"","slide_open_3":"0","slide_image_4":"","slide_title_4":"","slide_description_4":"","slide_intro_4":"","mbox_4":"0","mboxlink_4":"","mboxtype_4":"0","video_width_4":"640","video_height_4":"360","image_group_4":"0","image_group_name_4":"yjgallery","slide_link_4":"","slide_open_4":"0","slide_image_5":"","slide_title_5":"","slide_description_5":"","slide_intro_5":"","mbox_5":"0","mboxlink_5":"","mboxtype_5":"0","video_width_5":"640","video_height_5":"360","image_group_5":"0","image_group_name_5":"yjgallery","slide_link_5":"","slide_open_5":"0","slide_image_6":"","slide_title_6":"","slide_description_6":"","slide_intro_6":"","mbox_6":"0","mboxlink_6":"","mboxtype_6":"0","video_width_6":"640","video_height_6":"360","image_group_6":"0","image_group_name_6":"yjgallery","slide_link_6":"","slide_open_6":"0","slide_image_7":"","slide_title_7":"","slide_description_7":"","slide_intro_7":"","mbox_7":"0","mboxlink_7":"","mboxtype_7":"0","video_width_7":"640","video_height_7":"360","image_group_7":"0","image_group_name_7":"yjgallery","slide_link_7":"","slide_open_7":"0","slide_image_8":"","slide_title_8":"","slide_description_8":"","slide_intro_8":"","mbox_8":"0","mboxlink_8":"","mboxtype_8":"0","video_width_8":"640","video_height_8":"360","image_group_8":"0","image_group_name_8":"yjgallery","slide_link_8":"","slide_open_8":"0","slide_image_9":"","slide_title_9":"","slide_description_9":"","slide_intro_9":"","mbox_9":"0","mboxlink_9":"","mboxtype_9":"0","video_width_9":"640","video_height_9":"360","image_group_9":"0","image_group_name_9":"yjgallery","slide_link_9":"","slide_open_9":"0","slide_image_10":"","slide_title_10":"","slide_description_10":"","slide_intro_10":"","mbox_10":"0","mboxlink_10":"","mboxtype_10":"0","video_width_10":"640","video_height_10":"360","image_group_10":"0","image_group_name_10":"yjgallery","slide_link_10":"","slide_open_10":"0","slide_image_11":"","slide_title_11":"","slide_description_11":"","slide_intro_11":"","mbox_11":"0","mboxlink_11":"","mboxtype_11":"0","video_width_11":"640","video_height_11":"360","image_group_11":"0","image_group_name_11":"yjgallery","slide_link_11":"","slide_open_11":"0","slide_image_12":"","slide_title_12":"","slide_description_12":"","slide_intro_12":"","mbox_12":"0","mboxlink_12":"","mboxtype_12":"0","video_width_12":"640","video_height_12":"360","image_group_12":"0","image_group_name_12":"yjgallery","slide_link_12":"","slide_open_12":"0","slide_image_13":"","slide_title_13":"","slide_description_13":"","slide_intro_13":"","mbox_13":"0","mboxlink_13":"","mboxtype_13":"0","video_width_13":"640","video_height_13":"360","image_group_13":"0","image_group_name_13":"yjgallery","slide_link_13":"","slide_open_13":"0","slide_image_14":"","slide_title_14":"","slide_description_14":"","slide_intro_14":"","mbox_14":"0","mboxlink_14":"","mboxtype_14":"0","video_width_14":"640","video_height_14":"360","image_group_14":"0","image_group_name_14":"yjgallery","slide_link_14":"","slide_open_14":"0","slide_image_15":"","slide_title_15":"","slide_description_15":"","slide_intro_15":"","mbox_15":"0","mboxlink_15":"","mboxtype_15":"0","video_width_15":"640","video_height_15":"360","image_group_15":"0","image_group_name_15":"yjgallery","slide_link_15":"","slide_open_15":"0","slide_image_16":"","slide_title_16":"","slide_description_16":"","slide_intro_16":"","mbox_16":"0","mboxlink_16":"","mboxtype_16":"0","video_width_16":"640","video_height_16":"360","image_group_16":"0","image_group_name_16":"yjgallery","slide_link_16":"","slide_open_16":"0","slide_image_17":"","slide_title_17":"","slide_description_17":"","slide_intro_17":"","mbox_17":"0","mboxlink_17":"","mboxtype_17":"0","video_width_17":"640","video_height_17":"360","image_group_17":"0","image_group_name_17":"yjgallery","slide_link_17":"","slide_open_17":"0","slide_image_18":"","slide_title_18":"","slide_description_18":"","slide_intro_18":"","mbox_18":"0","mboxlink_18":"","mboxtype_18":"0","video_width_18":"640","video_height_18":"360","image_group_18":"0","image_group_name_18":"yjgallery","slide_link_18":"","slide_open_18":"0","slide_image_19":"","slide_title_19":"","slide_description_19":"","slide_intro_19":"","mbox_19":"0","mboxlink_19":"","mboxtype_19":"0","video_width_19":"640","video_height_19":"360","image_group_19":"0","image_group_name_19":"yjgallery","slide_link_19":"","slide_open_19":"0","slide_image_20":"","slide_title_20":"","slide_description_20":"","slide_intro_20":"","mbox_20":"0","mboxlink_20":"","mboxtype_20":"0","video_width_20":"640","video_height_20":"360","image_group_20":"0","image_group_name_20":"yjgallery","slide_link_20":"","slide_open_20":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10005, 'PKG_JOOMLA', 'package', 'pkg_joomla', '', 0, 1, 1, 1, '{"legacy":false,"name":"PKG_JOOMLA","type":"package","creationDate":"2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"http:\\/\\/www.joomla.org","version":"2.5.0","description":"PKG_JOOMLA_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(436, 'plg_system_languagecode', 'plugin', 'languagecode', 'system', 0, 0, 1, 0, '{"legacy":false,"name":"plg_system_languagecode","type":"plugin","creationDate":"November 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_SYSTEM_LANGUAGECODE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 10, 0),
(437, 'plg_quickicon_joomlaupdate', 'plugin', 'joomlaupdate', 'quickicon', 0, 1, 1, 1, '{"legacy":false,"name":"plg_quickicon_joomlaupdate","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.1","description":"PLG_QUICKICON_JOOMLAUPDATE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(438, 'plg_quickicon_extensionupdate', 'plugin', 'extensionupdate', 'quickicon', 0, 1, 1, 1, '{"legacy":false,"name":"plg_quickicon_extensionupdate","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.1","description":"PLG_QUICKICON_EXTENSIONUPDATE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(27, 'com_finder', 'component', 'com_finder', '', 1, 1, 0, 0, '', '{"show_description":"1","description_length":255,"allow_empty_query":"0","show_url":"1","show_advanced":"1","expand_advanced":"0","show_date_filters":"0","highlight_terms":"1","opensearch_name":"","opensearch_description":"","batch_size":"50","memory_table_limit":30000,"title_multiplier":"1.7","text_multiplier":"0.7","meta_multiplier":"1.2","path_multiplier":"2.0","misc_multiplier":"0.3","stemmer":"porter_en"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(439, 'plg_captcha_recaptcha', 'plugin', 'recaptcha', 'captcha', 0, 1, 1, 0, '{"legacy":false,"name":"plg_captcha_recaptcha","type":"plugin","creationDate":"December 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"2.5.0","description":"PLG_CAPTCHA_RECAPTCHA_XML_DESCRIPTION","group":""}', '{"public_key":"","private_key":"","theme":"clean"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(440, 'plg_system_highlight', 'plugin', 'highlight', 'system', 0, 1, 1, 0, '', '{}', '', '', 0, '0000-00-00 00:00:00', 7, 0),
(441, 'plg_content_finder', 'plugin', 'finder', 'content', 0, 0, 1, 0, '{"legacy":false,"name":"plg_content_finder","type":"plugin","creationDate":"December 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"PLG_CONTENT_FINDER_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(442, 'plg_finder_categories', 'plugin', 'categories', 'finder', 0, 1, 1, 0, '', '{}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(443, 'plg_finder_contacts', 'plugin', 'contacts', 'finder', 0, 1, 1, 0, '', '{}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(444, 'plg_finder_content', 'plugin', 'content', 'finder', 0, 1, 1, 0, '', '{}', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(445, 'plg_finder_newsfeeds', 'plugin', 'newsfeeds', 'finder', 0, 1, 1, 0, '', '{}', '', '', 0, '0000-00-00 00:00:00', 4, 0),
(446, 'plg_finder_weblinks', 'plugin', 'weblinks', 'finder', 0, 1, 1, 0, '', '{}', '', '', 0, '0000-00-00 00:00:00', 5, 0),
(223, 'mod_finder', 'module', 'mod_finder', '', 0, 1, 0, 0, '', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10006, 'mod_unread', 'module', 'mod_unread', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_unread","type":"module","creationDate":"Nov 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.6.0","description":"MOD_UNREAD_XML_DESCRIPTION","group":""}', '{"cache":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0);

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_filters`
--

DROP TABLE IF EXISTS `#__finder_filters`;
CREATE TABLE IF NOT EXISTS `#__finder_filters` (
  `filter_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) NOT NULL,
  `state` tinyint(1) NOT NULL DEFAULT '1',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL,
  `created_by_alias` varchar(255) NOT NULL,
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `map_count` int(10) unsigned NOT NULL DEFAULT '0',
  `data` text NOT NULL,
  `params` mediumtext,
  PRIMARY KEY (`filter_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_links`
--

DROP TABLE IF EXISTS `#__finder_links`;
CREATE TABLE IF NOT EXISTS `#__finder_links` (
  `link_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `url` varchar(255) NOT NULL,
  `route` varchar(255) NOT NULL,
  `title` varchar(255) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `indexdate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `md5sum` varchar(32) DEFAULT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '1',
  `state` int(5) DEFAULT '1',
  `access` int(5) DEFAULT '0',
  `language` varchar(8) NOT NULL,
  `publish_start_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_end_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `start_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `end_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `list_price` double unsigned NOT NULL DEFAULT '0',
  `sale_price` double unsigned NOT NULL DEFAULT '0',
  `type_id` int(11) NOT NULL,
  `object` mediumblob NOT NULL,
  PRIMARY KEY (`link_id`),
  KEY `idx_type` (`type_id`),
  KEY `idx_title` (`title`),
  KEY `idx_md5` (`md5sum`),
  KEY `idx_url` (`url`(75)),
  KEY `idx_published_list` (`published`,`state`,`access`,`publish_start_date`,`publish_end_date`,`list_price`),
  KEY `idx_published_sale` (`published`,`state`,`access`,`publish_start_date`,`publish_end_date`,`sale_price`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_links_terms0`
--

DROP TABLE IF EXISTS `#__finder_links_terms0`;
CREATE TABLE IF NOT EXISTS `#__finder_links_terms0` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_links_terms1`
--

DROP TABLE IF EXISTS `#__finder_links_terms1`;
CREATE TABLE IF NOT EXISTS `#__finder_links_terms1` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_links_terms2`
--

DROP TABLE IF EXISTS `#__finder_links_terms2`;
CREATE TABLE IF NOT EXISTS `#__finder_links_terms2` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_links_terms3`
--

DROP TABLE IF EXISTS `#__finder_links_terms3`;
CREATE TABLE IF NOT EXISTS `#__finder_links_terms3` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_links_terms4`
--

DROP TABLE IF EXISTS `#__finder_links_terms4`;
CREATE TABLE IF NOT EXISTS `#__finder_links_terms4` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_links_terms5`
--

DROP TABLE IF EXISTS `#__finder_links_terms5`;
CREATE TABLE IF NOT EXISTS `#__finder_links_terms5` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_links_terms6`
--

DROP TABLE IF EXISTS `#__finder_links_terms6`;
CREATE TABLE IF NOT EXISTS `#__finder_links_terms6` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_links_terms7`
--

DROP TABLE IF EXISTS `#__finder_links_terms7`;
CREATE TABLE IF NOT EXISTS `#__finder_links_terms7` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_links_terms8`
--

DROP TABLE IF EXISTS `#__finder_links_terms8`;
CREATE TABLE IF NOT EXISTS `#__finder_links_terms8` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_links_terms9`
--

DROP TABLE IF EXISTS `#__finder_links_terms9`;
CREATE TABLE IF NOT EXISTS `#__finder_links_terms9` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_links_termsa`
--

DROP TABLE IF EXISTS `#__finder_links_termsa`;
CREATE TABLE IF NOT EXISTS `#__finder_links_termsa` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_links_termsb`
--

DROP TABLE IF EXISTS `#__finder_links_termsb`;
CREATE TABLE IF NOT EXISTS `#__finder_links_termsb` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_links_termsc`
--

DROP TABLE IF EXISTS `#__finder_links_termsc`;
CREATE TABLE IF NOT EXISTS `#__finder_links_termsc` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_links_termsd`
--

DROP TABLE IF EXISTS `#__finder_links_termsd`;
CREATE TABLE IF NOT EXISTS `#__finder_links_termsd` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_links_termse`
--

DROP TABLE IF EXISTS `#__finder_links_termse`;
CREATE TABLE IF NOT EXISTS `#__finder_links_termse` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_links_termsf`
--

DROP TABLE IF EXISTS `#__finder_links_termsf`;
CREATE TABLE IF NOT EXISTS `#__finder_links_termsf` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_taxonomy`
--

DROP TABLE IF EXISTS `#__finder_taxonomy`;
CREATE TABLE IF NOT EXISTS `#__finder_taxonomy` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL,
  `state` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `access` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ordering` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `parent_id` (`parent_id`),
  KEY `state` (`state`),
  KEY `ordering` (`ordering`),
  KEY `access` (`access`),
  KEY `idx_parent_published` (`parent_id`,`state`,`access`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;

--
-- Dumping data for table `#__finder_taxonomy`
--

INSERT INTO `#__finder_taxonomy` (`id`, `parent_id`, `title`, `state`, `access`, `ordering`) VALUES
(1, 0, 'ROOT', 0, 0, 0);

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_taxonomy_map`
--

DROP TABLE IF EXISTS `#__finder_taxonomy_map`;
CREATE TABLE IF NOT EXISTS `#__finder_taxonomy_map` (
  `link_id` int(10) unsigned NOT NULL,
  `node_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`node_id`),
  KEY `link_id` (`link_id`),
  KEY `node_id` (`node_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_terms`
--

DROP TABLE IF EXISTS `#__finder_terms`;
CREATE TABLE IF NOT EXISTS `#__finder_terms` (
  `term_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `weight` float unsigned NOT NULL DEFAULT '0',
  `soundex` varchar(75) NOT NULL,
  `links` int(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_id`),
  UNIQUE KEY `idx_term` (`term`),
  KEY `idx_term_phrase` (`term`,`phrase`),
  KEY `idx_stem_phrase` (`stem`,`phrase`),
  KEY `idx_soundex_phrase` (`soundex`,`phrase`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_terms_common`
--

DROP TABLE IF EXISTS `#__finder_terms_common`;
CREATE TABLE IF NOT EXISTS `#__finder_terms_common` (
  `term` varchar(75) NOT NULL,
  `language` varchar(3) NOT NULL,
  KEY `idx_word_lang` (`term`,`language`),
  KEY `idx_lang` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `#__finder_terms_common`
--

INSERT INTO `#__finder_terms_common` (`term`, `language`) VALUES
('a', 'en'),
('about', 'en'),
('after', 'en'),
('ago', 'en'),
('all', 'en'),
('am', 'en'),
('an', 'en'),
('and', 'en'),
('ani', 'en'),
('any', 'en'),
('are', 'en'),
('aren''t', 'en'),
('as', 'en'),
('at', 'en'),
('be', 'en'),
('but', 'en'),
('by', 'en'),
('for', 'en'),
('from', 'en'),
('get', 'en'),
('go', 'en'),
('how', 'en'),
('if', 'en'),
('in', 'en'),
('into', 'en'),
('is', 'en'),
('isn''t', 'en'),
('it', 'en'),
('its', 'en'),
('me', 'en'),
('more', 'en'),
('most', 'en'),
('must', 'en'),
('my', 'en'),
('new', 'en'),
('no', 'en'),
('none', 'en'),
('not', 'en'),
('noth', 'en'),
('nothing', 'en'),
('of', 'en'),
('off', 'en'),
('often', 'en'),
('old', 'en'),
('on', 'en'),
('onc', 'en'),
('once', 'en'),
('onli', 'en'),
('only', 'en'),
('or', 'en'),
('other', 'en'),
('our', 'en'),
('ours', 'en'),
('out', 'en'),
('over', 'en'),
('page', 'en'),
('she', 'en'),
('should', 'en'),
('small', 'en'),
('so', 'en'),
('some', 'en'),
('than', 'en'),
('thank', 'en'),
('that', 'en'),
('the', 'en'),
('their', 'en'),
('theirs', 'en'),
('them', 'en'),
('then', 'en'),
('there', 'en'),
('these', 'en'),
('they', 'en'),
('this', 'en'),
('those', 'en'),
('thus', 'en'),
('time', 'en'),
('times', 'en'),
('to', 'en'),
('too', 'en'),
('true', 'en'),
('under', 'en'),
('until', 'en'),
('up', 'en'),
('upon', 'en'),
('use', 'en'),
('user', 'en'),
('users', 'en'),
('veri', 'en'),
('version', 'en'),
('very', 'en'),
('via', 'en'),
('want', 'en'),
('was', 'en'),
('way', 'en'),
('were', 'en'),
('what', 'en'),
('when', 'en'),
('where', 'en'),
('whi', 'en'),
('which', 'en'),
('who', 'en'),
('whom', 'en'),
('whose', 'en'),
('why', 'en'),
('wide', 'en'),
('will', 'en'),
('with', 'en'),
('within', 'en'),
('without', 'en'),
('would', 'en'),
('yes', 'en'),
('yet', 'en'),
('you', 'en'),
('your', 'en'),
('yours', 'en');

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_tokens`
--

DROP TABLE IF EXISTS `#__finder_tokens`;
CREATE TABLE IF NOT EXISTS `#__finder_tokens` (
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `weight` float unsigned NOT NULL DEFAULT '1',
  `context` tinyint(1) unsigned NOT NULL DEFAULT '2',
  KEY `idx_word` (`term`),
  KEY `idx_context` (`context`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_tokens_aggregate`
--

DROP TABLE IF EXISTS `#__finder_tokens_aggregate`;
CREATE TABLE IF NOT EXISTS `#__finder_tokens_aggregate` (
  `term_id` int(10) unsigned NOT NULL,
  `map_suffix` char(1) NOT NULL,
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `term_weight` float unsigned NOT NULL,
  `context` tinyint(1) unsigned NOT NULL DEFAULT '2',
  `context_weight` float unsigned NOT NULL,
  `total_weight` float unsigned NOT NULL,
  KEY `token` (`term`),
  KEY `keyword_id` (`term_id`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `#__finder_types`
--

DROP TABLE IF EXISTS `#__finder_types`;
CREATE TABLE IF NOT EXISTS `#__finder_types` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL,
  `mime` varchar(100) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `title` (`title`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Table structure for table `#__languages`
--

DROP TABLE IF EXISTS `#__languages`;
CREATE TABLE IF NOT EXISTS `#__languages` (
  `lang_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `lang_code` char(7) NOT NULL,
  `title` varchar(50) NOT NULL,
  `title_native` varchar(50) NOT NULL,
  `sef` varchar(50) NOT NULL,
  `image` varchar(50) NOT NULL,
  `description` varchar(512) NOT NULL,
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `sitename` varchar(1024) NOT NULL DEFAULT '',
  `published` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`lang_id`),
  UNIQUE KEY `idx_sef` (`sef`),
  UNIQUE KEY `idx_image` (`image`),
  UNIQUE KEY `idx_langcode` (`lang_code`),
  KEY `idx_ordering` (`ordering`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;

--
-- Dumping data for table `#__languages`
--

INSERT INTO `#__languages` (`lang_id`, `lang_code`, `title`, `title_native`, `sef`, `image`, `description`, `metakey`, `metadesc`, `sitename`, `published`, `ordering`) VALUES
(1, 'en-GB', 'English (UK)', 'English (UK)', 'en', 'en', '', '', '', '', 1, 0);

-- --------------------------------------------------------

--
-- Table structure for table `#__menu`
--

DROP TABLE IF EXISTS `#__menu`;
CREATE TABLE IF NOT EXISTS `#__menu` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) NOT NULL COMMENT 'The type of menu this item belongs to. FK to #__menu_types.menutype',
  `title` varchar(255) NOT NULL COMMENT 'The display title of the menu item.',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL COMMENT 'The SEF alias of the menu item.',
  `note` varchar(255) NOT NULL DEFAULT '',
  `path` varchar(1024) NOT NULL COMMENT 'The computed path of the menu item based on the alias field.',
  `link` varchar(1024) NOT NULL COMMENT 'The actually link the menu item refers to.',
  `type` varchar(16) NOT NULL COMMENT 'The type of link: Component, URL, Alias, Separator',
  `published` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The published state of the menu link.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '1' COMMENT 'The parent menu item in the menu tree.',
  `level` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The relative level in the tree.',
  `component_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to #__extensions.id',
  `ordering` int(11) NOT NULL DEFAULT '0' COMMENT 'The relative ordering of the menu item in the tree.',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to #__users.id',
  `checked_out_time` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'The time the menu item was checked out.',
  `browserNav` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The click behaviour of the link.',
  `access` int(10) unsigned DEFAULT NULL,
  `img` varchar(255) NOT NULL COMMENT 'The image of the menu item.',
  `template_style_id` int(10) unsigned NOT NULL DEFAULT '0',
  `params` text NOT NULL COMMENT 'JSON encoded data for the menu item.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `home` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Indicates if this menu item is the home or default page.',
  `language` char(7) NOT NULL DEFAULT '',
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_client_id_parent_id_alias_language` (`client_id`,`parent_id`,`alias`,`language`),
  KEY `idx_componentid` (`component_id`,`menutype`,`published`,`access`),
  KEY `idx_menutype` (`menutype`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_path` (`path`(333)),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=203 ;

--
-- Dumping data for table `#__menu`
--

INSERT INTO `#__menu` (`id`, `menutype`, `title`, `alias`, `note`, `path`, `link`, `type`, `published`, `parent_id`, `level`, `component_id`, `ordering`, `checked_out`, `checked_out_time`, `browserNav`, `access`, `img`, `template_style_id`, `params`, `lft`, `rgt`, `home`, `language`, `client_id`) VALUES
(1, '', 'Menu_Item_Root', 'root', '', '', '', '', 1, 0, 0, 0, 0, 0, '0000-00-00 00:00:00', 0, 0, '', 0, '', 0, 233, 0, '*', 0),
(2, 'menu', 'com_banners', 'Banners', '', 'Banners', 'index.php?option=com_banners', 'component', 0, 1, 1, 4, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners', 0, '', 1, 10, 0, '*', 1),
(3, 'menu', 'com_banners', 'Banners', '', 'Banners/Banners', 'index.php?option=com_banners', 'component', 0, 2, 2, 4, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners', 0, '', 2, 3, 0, '*', 1),
(4, 'menu', 'com_banners_categories', 'Categories', '', 'Banners/Categories', 'index.php?option=com_categories&extension=com_banners', 'component', 0, 2, 2, 6, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners-cat', 0, '', 4, 5, 0, '*', 1),
(5, 'menu', 'com_banners_clients', 'Clients', '', 'Banners/Clients', 'index.php?option=com_banners&view=clients', 'component', 0, 2, 2, 4, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners-clients', 0, '', 6, 7, 0, '*', 1),
(6, 'menu', 'com_banners_tracks', 'Tracks', '', 'Banners/Tracks', 'index.php?option=com_banners&view=tracks', 'component', 0, 2, 2, 4, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners-tracks', 0, '', 8, 9, 0, '*', 1),
(7, 'menu', 'com_contact', 'Contacts', '', 'Contacts', 'index.php?option=com_contact', 'component', 0, 1, 1, 8, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:contact', 0, '', 201, 206, 0, '*', 1),
(8, 'menu', 'com_contact', 'Contacts', '', 'Contacts/Contacts', 'index.php?option=com_contact', 'component', 0, 7, 2, 8, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:contact', 0, '', 202, 203, 0, '*', 1),
(9, 'menu', 'com_contact_categories', 'Categories', '', 'Contacts/Categories', 'index.php?option=com_categories&extension=com_contact', 'component', 0, 7, 2, 6, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:contact-cat', 0, '', 204, 205, 0, '*', 1),
(10, 'menu', 'com_messages', 'Messaging', '', 'Messaging', 'index.php?option=com_messages', 'component', 0, 1, 1, 15, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:messages', 0, '', 207, 212, 0, '*', 1),
(11, 'menu', 'com_messages_add', 'New Private Message', '', 'Messaging/New Private Message', 'index.php?option=com_messages&task=message.add', 'component', 0, 10, 2, 15, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:messages-add', 0, '', 208, 209, 0, '*', 1),
(12, 'menu', 'com_messages_read', 'Read Private Message', '', 'Messaging/Read Private Message', 'index.php?option=com_messages', 'component', 0, 10, 2, 15, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:messages-read', 0, '', 210, 211, 0, '*', 1),
(13, 'menu', 'com_newsfeeds', 'News Feeds', '', 'News Feeds', 'index.php?option=com_newsfeeds', 'component', 0, 1, 1, 17, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:newsfeeds', 0, '', 213, 218, 0, '*', 1),
(14, 'menu', 'com_newsfeeds_feeds', 'Feeds', '', 'News Feeds/Feeds', 'index.php?option=com_newsfeeds', 'component', 0, 13, 2, 17, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:newsfeeds', 0, '', 214, 215, 0, '*', 1),
(15, 'menu', 'com_newsfeeds_categories', 'Categories', '', 'News Feeds/Categories', 'index.php?option=com_categories&extension=com_newsfeeds', 'component', 0, 13, 2, 6, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:newsfeeds-cat', 0, '', 216, 217, 0, '*', 1),
(16, 'menu', 'com_redirect', 'Redirect', '', 'Redirect', 'index.php?option=com_redirect', 'component', 0, 1, 1, 24, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:redirect', 0, '', 227, 228, 0, '*', 1),
(17, 'menu', 'com_search', 'Search', '', 'Search', 'index.php?option=com_search', 'component', 0, 1, 1, 19, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:search', 0, '', 219, 220, 0, '*', 1),
(18, 'menu', 'com_weblinks', 'Weblinks', '', 'Weblinks', 'index.php?option=com_weblinks', 'component', 0, 1, 1, 21, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:weblinks', 0, '', 221, 226, 0, '*', 1),
(19, 'menu', 'com_weblinks_links', 'Links', '', 'Weblinks/Links', 'index.php?option=com_weblinks', 'component', 0, 18, 2, 21, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:weblinks', 0, '', 222, 223, 0, '*', 1),
(20, 'menu', 'com_weblinks_categories', 'Categories', '', 'Weblinks/Categories', 'index.php?option=com_categories&extension=com_weblinks', 'component', 0, 18, 2, 6, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:weblinks-cat', 0, '', 224, 225, 0, '*', 1),
(101, 'mainmenu', 'Home', 'home', '', 'home', 'index.php?option=com_content&view=featured', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","num_leading_articles":"0","num_intro_articles":"0","num_columns":"0","num_links":"0","multi_column_order":"1","orderby_pri":"","orderby_sec":"front","order_date":"created","show_pagination":"0","show_pagination_results":"0","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"0","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"0","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"YouDesigns - Designer Portfolio Template","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"YJSG Demo","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 11, 12, 1, '*', 0),
(102, 'mainmenu', 'About YJSG', 'about-yjsg', '', 'about-yjsg', '', 'url', 1, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"yj_menu_sub_title":"Joomla Framework","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 59, 84, 0, '*', 0),
(103, 'mainmenu', 'YJSG Features', 'yjsg-features', '', 'about-yjsg/yjsg-features', 'index.php?option=com_content&view=article&id=9', 'component', 1, 102, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 60, 61, 0, '*', 0),
(104, 'mainmenu', 'Grids Preview', 'grids-preview', '', 'about-yjsg/grids-preview', 'index.php?option=com_content&view=article&id=8', 'component', 1, 102, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"0","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 62, 63, 0, '*', 0),
(105, 'mainmenu', 'Default Grid Layouts', 'default-grid-layouts', '', 'about-yjsg/default-grid-layouts', '#', 'url', 1, 102, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 64, 73, 0, '*', 0),
(106, 'mainmenu', 'User Pages', 'user-pages', '', 'features/user-pages', '#', 'url', 1, 112, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"yj_menu_sub_title":"Custom Joomla! user pages","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 14, 27, 0, '*', 0),
(107, 'mainmenu', 'Login Form', 'login-form', '', 'features/user-pages/login-form', 'index.php?option=com_users&view=login', 'component', 1, 106, 3, 25, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"login_redirect_url":"","logindescription_show":"1","login_description":"","login_image":"","logout_redirect_url":"","logoutdescription_show":"1","logout_description":"","logout_image":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"Joomla! User Login ","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"Login Form demo","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 15, 16, 0, '*', 0),
(108, 'mainmenu', 'User Profile ', 'user-profile', '', 'features/user-pages/user-profile', 'index.php?option=com_users&view=profile', 'component', 1, 106, 3, 25, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"User Profile ","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"User Profile Demo","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 17, 18, 0, '*', 0),
(109, 'mainmenu', 'User Regisrtation', 'user-regisrtation', '', 'features/user-pages/user-regisrtation', 'index.php?option=com_users&view=registration', 'component', 1, 106, 3, 25, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"Registration","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"User Regisrtation Demo","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 19, 20, 0, '*', 0),
(110, 'mainmenu', 'Username Reminder', 'username-reminder', '', 'features/user-pages/username-reminder', 'index.php?option=com_users&view=remind', 'component', 1, 106, 3, 25, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"Forgot your Username? ","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"Username Reminder Demo","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 21, 22, 0, '*', 0),
(111, 'mainmenu', 'Password reset', 'password-reset', '', 'features/user-pages/password-reset', 'index.php?option=com_users&view=reset', 'component', 1, 106, 3, 25, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"Forgot your Password? ","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"Password reset demo","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 23, 24, 0, '*', 0),
(112, 'mainmenu', 'Features', 'features', '', 'features', '#', 'url', 1, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"yj_menu_sub_title":"Template Features","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 13, 58, 0, '*', 0),
(113, 'mainmenu', '404 page', '404-page', '', 'features/user-pages/404-page', 'index.php?Itemid=8888', 'url', 1, 106, 3, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"yj_menu_sub_title":"404 page demo","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 25, 26, 0, '*', 0),
(120, 'mainmenu', 'Menus with image', 'menus-with-image', '', 'menu-combos/menus-with-image', '#', 'url', 1, 119, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 152, 159, 0, '*', 0),
(121, 'mainmenu', 'Menus with sub title', 'menus-with-sub-title', '', 'menu-combos/menus-with-sub-title', '#', 'url', 1, 119, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 160, 167, 0, '*', 0),
(122, 'mainmenu', 'Menus with image and sub title', 'menus-with-image-and-subtitle', '', 'menu-combos/menus-with-image-and-subtitle', '#', 'url', 1, 119, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 168, 175, 0, '*', 0),
(124, 'mainmenu', 'Mega Menu', 'mega-menu', '', 'mega-menu', 'index.php?option=com_content&view=article&id=10', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"Mega Menu Demo","yj_menu_custom_class":"","yj_group_holder":"1","yj_menu_holder_width":"720","yj_menu_groups_count":"3","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 85, 150, 0, '*', 0),
(119, 'mainmenu', 'Menu Combos', 'menu-combos', '', 'menu-combos', '#', 'url', 1, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"yj_menu_sub_title":"Menu Combination","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 151, 176, 0, '*', 0),
(115, 'mainmenu', 'Left-Mid-Right', 'left-mid-right', '', 'about-yjsg/default-grid-layouts/left-mid-right', '?change_layout=1', 'url', 1, 105, 3, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 65, 66, 0, '*', 0),
(116, 'mainmenu', 'Mid-Left-Right', 'mid-left-right', '', 'about-yjsg/default-grid-layouts/mid-left-right', '?change_layout=2', 'url', 1, 105, 3, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 67, 68, 0, '*', 0),
(117, 'mainmenu', 'Left-Right-Mid', 'left-right-mid', '', 'about-yjsg/default-grid-layouts/left-right-mid', '?change_layout=3', 'url', 1, 105, 3, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 69, 70, 0, '*', 0),
(118, 'mainmenu', 'Ifamily View', 'ifamily-view', '', 'about-yjsg/default-grid-layouts/ifamily-view', '?change_mobile=1', 'url', 1, 105, 3, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 71, 72, 0, '*', 0),
(123, 'mainmenu', 'Jstuff', 'jstuff', '', 'jstuff', '#', 'url', 0, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"yj_menu_sub_title":"JDefaults","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 177, 194, 0, '*', 0),
(125, 'mainmenu', 'JTuts', 'jtuts', '', 'jtuts', 'http://www.youjoomla.com/joomla-installation-tutorials.html', 'url', 0, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 1, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"yj_menu_sub_title":"Tutorials","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 195, 196, 0, '*', 0),
(126, 'mainmenu', 'Login', 'login', '', 'login', '#', 'url', 0, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"yj_menu_sub_title":"Site login","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 197, 200, 0, '*', 0),
(129, 'mainmenu', 'Content Views', 'content-views', '', 'jstuff/content-views', 'index.php?option=com_content&view=category&id=7', 'component', 0, 123, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_category_title":"1","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","show_pagination_limit":"","filter_field":"","show_headings":"","list_show_date":"","date_format":"","list_show_hits":"","list_show_author":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","display_num":"10","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 178, 187, 0, '*', 0),
(132, 'mainmenu', 'Contacts', 'contacts', '', 'jstuff/contacts', 'index.php?option=com_contact&view=categories&id=0', 'component', 0, 123, 2, 8, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_base_description":"","categories_description":"","maxLevelcat":"","show_empty_categories_cat":"","show_subcat_desc_cat":"","show_cat_items_cat":"","show_category_title":"0","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_subcat_desc":"","show_cat_items":"","show_pagination_limit":"","show_headings":"","show_position_headings":"","show_email_headings":"","show_telephone_headings":"","show_mobile_headings":"","show_fax_headings":"","show_suburb_headings":"","show_state_headings":"","show_country_headings":"","show_pagination":"","show_pagination_results":"","presentation_style":"","show_contact_category":"","show_contact_list":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_links":"","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"Site Contact","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 190, 191, 0, '*', 0),
(131, 'mainmenu', 'Web links', 'web-links', '', 'jstuff/web-links', 'index.php?option=com_weblinks&view=categories&id=0', 'component', 0, 123, 2, 21, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_base_description":"","categories_description":"","maxLevelcat":"-1","show_empty_categories_cat":"","show_subcat_desc_cat":"","show_cat_num_links_cat":"","show_category_title":"0","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_subcat_desc":"","show_cat_num_links":"","show_pagination_limit":"1","show_headings":"1","show_link_description":"1","show_link_hits":"1","show_pagination":"1","show_pagination_results":"1","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 188, 189, 0, '*', 0),
(133, 'mainmenu', 'Newsfeeds', 'newsfeeds', '', 'jstuff/newsfeeds', 'index.php?option=com_newsfeeds&view=categories&id=0', 'component', 0, 123, 2, 17, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_base_description":"","categories_description":"","maxLevelcat":"","show_empty_categories_cat":"","show_subcat_desc_cat":"","show_cat_items_cat":"","show_category_title":"0","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_subcat_desc":"","show_cat_items":"","show_pagination_limit":"","show_headings":"","show_articles":"","show_link":"","show_pagination":"","show_pagination_results":"","show_feed_image":"","show_feed_description":"","show_item_description":"","feed_character_count":"0","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"Newsfeeds","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 192, 193, 0, '*', 0),
(134, 'mainmenu', 'Category Blog View', 'category-blog-view', '', 'jstuff/content-views/category-blog-view', 'index.php?option=com_content&view=category&layout=blog&id=2', 'component', 0, 129, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"","multi_column_order":"","show_subcategory_content":"","orderby_pri":"","orderby_sec":"front","order_date":"","show_pagination":"","show_pagination_results":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 179, 180, 0, '*', 0),
(135, 'mainmenu', 'Category List View', 'category-list-view', '', 'jstuff/content-views/category-list-view', 'index.php?option=com_content&view=category&id=2', 'component', 0, 129, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_category_title":"1","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","show_pagination_limit":"1","filter_field":"title","show_headings":"1","list_show_date":"created","date_format":"","list_show_hits":"1","list_show_author":"1","orderby_pri":"","orderby_sec":"front","order_date":"","show_pagination":"","show_pagination_results":"","display_num":"10","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 181, 182, 0, '*', 0),
(136, 'mainmenu', 'Categories View', 'categories-view', '', 'jstuff/content-views/categories-view', 'index.php?option=com_content&view=categories&id=0', 'component', 0, 129, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_base_description":"","categories_description":"","maxLevelcat":"","show_empty_categories_cat":"","show_subcat_desc_cat":"","show_cat_num_articles_cat":"","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_pagination_limit":"","filter_field":"","show_headings":"","list_show_date":"","date_format":"","list_show_hits":"","list_show_author":"","display_num":"10","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":1,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 183, 184, 0, '*', 0),
(137, 'mainmenu', 'Archived View', 'archived-view', '', 'jstuff/content-views/archived-view', 'index.php?option=com_content&view=archive', 'component', 0, 129, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"orderby_sec":"alpha","order_date":"created","display_num":"5","filter_field":"hide","introtext_limit":"100","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_title":"","link_titles":"","show_intro":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_hits":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 185, 186, 0, '*', 0),
(138, 'mainmenu', 'Menu Types', 'menu-types', '', 'features/menu-types', 'index.php?option=com_content&view=article&id=8', 'component', 1, 112, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"Choose Your Menu Type","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 28, 39, 0, '*', 0),
(139, 'mainmenu', 'YJ Mega CSS Dropdown', 'yj-mega-css-dropdown', '', 'features/menu-types/yj-mega-css-dropdown', '?change_menu=1', 'url', 1, 138, 3, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 29, 30, 0, '*', 0),
(140, 'mainmenu', 'YJ Mega Smooth Dropdown', 'yj-mega-smooth-dropdown', '', 'features/menu-types/yj-mega-smooth-dropdown', '?change_menu=2', 'url', 1, 138, 3, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 31, 32, 0, '*', 0),
(141, 'mainmenu', 'YJ Mega CSS Dropline', 'yj-mega-css-dropline', '', 'features/menu-types/yj-mega-css-dropline', '?change_menu=3', 'url', 1, 138, 3, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 33, 34, 0, '*', 0),
(142, 'mainmenu', 'YJ Mega Smooth Dropline', 'yj-mega-smooth-dropline', '', 'features/menu-types/yj-mega-smooth-dropline', '?change_menu=4', 'url', 1, 138, 3, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 35, 36, 0, '*', 0),
(143, 'mainmenu', 'Joomla Split Menu', 'joomla-split-menu', '', 'features/menu-types/joomla-split-menu', 'index.php?option=com_content&view=article&id=8&Itemid=138&change_menu=5', 'url', 1, 138, 3, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 37, 38, 0, '*', 0),
(144, 'mainmenu', 'Typography', 'typography', '', 'features/typography', 'index.php?option=com_content&view=article&id=12', 'component', 1, 112, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"Style your site content","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 50, 51, 0, '*', 0),
(145, 'mainmenu', 'Template Styles', 'template-styles', '', 'features/template-styles', '#', 'url', 1, 112, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"yj_menu_sub_title":"Choose Your Template Style","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 40, 49, 0, '*', 0),
(146, 'mainmenu', 'Blue', 'blue', '', 'features/template-styles/blue', '?change_css=blue', 'url', 1, 145, 3, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"yj_menu_sub_title":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 41, 42, 0, '*', 0),
(147, 'mainmenu', 'Orange', 'orange', '', 'features/template-styles/orange', '?change_css=orange', 'url', 1, 145, 3, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"yj_menu_sub_title":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 43, 44, 0, '*', 0),
(148, 'mainmenu', 'Green', 'green', '', 'features/template-styles/green', '?change_css=green', 'url', 1, 145, 3, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"yj_menu_sub_title":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 45, 46, 0, '*', 0),
(149, 'mainmenu', 'Module Positions', 'module-positions', '', 'features/module-positions', 'index.php?option=com_content&view=article&id=13', 'component', 1, 112, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"Over 50 module positions ","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 52, 53, 0, '*', 0),
(150, 'mainmenu', 'Adding New Grid', 'adding-new-grid', '', 'about-yjsg/adding-new-grid', 'http://www.joomla1.5.youjoomla.info/yougrids/yjsg-framework/adding-new-grid.html', 'url', 1, 102, 2, 0, 0, 0, '0000-00-00 00:00:00', 1, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 74, 75, 0, '*', 0),
(151, 'mainmenu', 'Template Manager', 'template-manager', '', 'about-yjsg/template-manager', 'http://www.joomla1.5.youjoomla.info/yougrids/yjsg-framework/template-manager.html', 'url', 1, 102, 2, 0, 0, 0, '0000-00-00 00:00:00', 1, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 76, 77, 0, '*', 0),
(152, 'mainmenu', 'Adding new style', 'adding-new-style', '', 'about-yjsg/adding-new-style', 'http://www.joomla1.5.youjoomla.info/yougrids/yjsg-framework/adding-new-style.html', 'url', 1, 102, 2, 0, 0, 0, '0000-00-00 00:00:00', 1, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 78, 79, 0, '*', 0),
(153, 'mainmenu', 'YJSG Structure', 'yjsg-structure', '', 'about-yjsg/yjsg-structure', 'http://yjsimplegrid.com/docs/yjsimplegrid-structure.html', 'url', 1, 102, 2, 0, 0, 0, '0000-00-00 00:00:00', 1, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 82, 83, 0, '*', 0),
(154, 'mainmenu', 'YJSG License', 'yjsg-license', '', 'about-yjsg/yjsg-license', 'http://yjsimplegrid.com/docs/yjsg-license.html', 'url', 1, 102, 2, 0, 0, 0, '0000-00-00 00:00:00', 1, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 80, 81, 0, '*', 0),
(155, 'mainmenu', 'YJSG Mega Menu', 'yjsg-mega-menu', '', 'features/yjsg-mega-menu', 'index.php?option=com_content&view=article&id=10', 'component', 1, 112, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"0","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"Joomla Mega Menu","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 54, 55, 0, '*', 0),
(156, 'footer-menu', 'YJSimpleGrid Features', 'yjsimplegrid-features', '', 'yjsimplegrid-features', 'index.php?option=com_content&view=article&id=9', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 229, 230, 0, '*', 0),
(157, 'footer-menu', 'Joomla! News', 'joomla-news', '', 'joomla-news', 'index.php?option=com_newsfeeds&view=newsfeed&id=2', 'component', 1, 1, 1, 17, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_feed_image":"","show_feed_description":"","show_item_description":"","feed_character_count":"0","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 231, 232, 0, '*', 0),
(158, 'mainmenu', 'Group1', 'group1', '', 'mega-menu/group1', 'index.php?option=com_content&view=article&id=10', 'component', 1, 124, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"","yj_menu_custom_class":"","yj_group_holder":"1","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 86, 133, 0, '*', 0),
(159, 'mainmenu', 'Sub Group', 'sub-group', '', 'mega-menu/group1/sub-group', 'index.php?option=com_content&view=article&id=10', 'component', 1, 158, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/stories\\/1.png","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"","yj_menu_custom_class":"","yj_group_holder":"1","yj_menu_holder_width":"500","yj_menu_groups_count":"2","yj_sub_group_width":"200\\r\\n300","yj_item_type":"0","yj_menu_show_title":"1"}', 87, 108, 0, '*', 0),
(160, 'mainmenu', 'Group mix', 'group-mix', '', 'mega-menu/group1/group-mix', 'index.php?option=com_content&view=article&id=10', 'component', 1, 158, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/stories\\/3.png","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"","yj_menu_custom_class":"","yj_group_holder":"1","yj_menu_holder_width":"500","yj_menu_groups_count":"3","yj_sub_group_width":"200\\r\\n150\\r\\n150","yj_item_type":"0","yj_menu_show_title":"1"}', 109, 128, 0, '*', 0),
(161, 'mainmenu', 'Module', 'module', '', 'mega-menu/group1/module', 'index.php?option=com_content&view=article&id=10', 'component', 1, 158, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/stories\\/9.png","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 129, 132, 0, '*', 0),
(162, 'mainmenu', 'Group2', 'group2', '', 'mega-menu/group2', 'index.php?option=com_content&view=article&id=10', 'component', 1, 124, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 134, 141, 0, '*', 0),
(163, 'mainmenu', 'Group3', 'group3', '', 'mega-menu/group3', 'index.php?option=com_content&view=article&id=10', 'component', 1, 124, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 142, 149, 0, '*', 0),
(164, 'mainmenu', 'Group2 Item1', 'group2-item1', '', 'mega-menu/group2/group2-item1', 'index.php?option=com_content&view=article&id=10', 'component', 1, 162, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/stories\\/7.png","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 135, 136, 0, '*', 0),
(165, 'mainmenu', 'Group2 Item2', 'group2-item2', '', 'mega-menu/group2/group2-item2', 'index.php?option=com_content&view=article&id=10', 'component', 1, 162, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/stories\\/8.png","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 137, 138, 0, '*', 0),
(166, 'mainmenu', 'Group2 Item3', 'group2-item3', '', 'mega-menu/group2/group2-item3', 'index.php?option=com_content&view=article&id=5', 'component', 1, 162, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/stories\\/2.png","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 139, 140, 0, '*', 0),
(167, 'mainmenu', 'Group3 Item1', 'group3-item1', '', 'mega-menu/group3/group3-item1', 'index.php?option=com_content&view=article&id=1', 'component', 1, 163, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/stories\\/4.png","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 143, 144, 0, '*', 0),
(168, 'mainmenu', 'Group3 Item2', 'group3-item2', '', 'mega-menu/group3/group3-item2', 'index.php?option=com_content&view=article&id=13', 'component', 1, 163, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/stories\\/6.png","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 145, 146, 0, '*', 0);
INSERT INTO `#__menu` (`id`, `menutype`, `title`, `alias`, `note`, `path`, `link`, `type`, `published`, `parent_id`, `level`, `component_id`, `ordering`, `checked_out`, `checked_out_time`, `browserNav`, `access`, `img`, `template_style_id`, `params`, `lft`, `rgt`, `home`, `language`, `client_id`) VALUES
(169, 'mainmenu', 'Group3 Item3', 'group3-item3', '', 'mega-menu/group3/group3-item3', 'index.php?option=com_content&view=article&id=12', 'component', 1, 163, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/stories\\/2.png","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 147, 148, 0, '*', 0),
(170, 'mainmenu', 'Sub Group1', 'sub-group1', '', 'mega-menu/group1/sub-group/sub-group1', 'index.php?option=com_content&view=article&id=8', 'component', 1, 159, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 88, 99, 0, '*', 0),
(171, 'mainmenu', 'Sub Group2', 'sub-group2', '', 'mega-menu/group1/sub-group/sub-group2', 'index.php?option=com_content&view=article&id=13', 'component', 1, 159, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 100, 107, 0, '*', 0),
(172, 'mainmenu', 'SG1 Item1', 'sg1-item1', '', 'mega-menu/group1/sub-group/sub-group1/sg1-item1', 'index.php?option=com_content&view=article&id=8', 'component', 1, 170, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/stories\\/13.png","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 89, 94, 0, '*', 0),
(173, 'mainmenu', 'SG1 Item2', 'sg1-item2', '', 'mega-menu/group1/sub-group/sub-group1/sg1-item2', 'index.php?option=com_content&view=article&id=13', 'component', 1, 170, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/stories\\/10.png","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 95, 96, 0, '*', 0),
(174, 'mainmenu', 'SG1 Item3', 'sg1-item3', '', 'mega-menu/group1/sub-group/sub-group1/sg1-item3', 'index.php?option=com_content&view=article&id=1', 'component', 1, 170, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/stories\\/15.png","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 97, 98, 0, '*', 0),
(175, 'mainmenu', 'SG2 Item1', 'sg2-item1', '', 'mega-menu/group1/sub-group/sub-group2/sg2-item1', 'index.php?option=com_content&view=article&id=12', 'component', 1, 171, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/stories\\/10.png","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 101, 102, 0, '*', 0),
(176, 'mainmenu', 'SG2 Item2', 'sg2-item2', '', 'mega-menu/group1/sub-group/sub-group2/sg2-item2', 'index.php?option=com_content&view=article&id=3', 'component', 1, 171, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/stories\\/5.png","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 103, 104, 0, '*', 0),
(177, 'mainmenu', 'SG2 Item3', 'sg2-item3', '', 'mega-menu/group1/sub-group/sub-group2/sg2-item3', 'index.php?option=com_content&view=article&id=5', 'component', 1, 171, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/stories\\/14.png","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 105, 106, 0, '*', 0),
(178, 'mainmenu', 'Module Demo', 'module-demo', '', 'mega-menu/group1/module/module-demo', '#', 'url', 1, 161, 4, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"yj_menu_sub_title":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"1","yj_menu_show_title":"2","yj_mod_id":["30"]}', 130, 131, 0, '*', 0),
(179, 'mainmenu', 'Module position in group mix', 'module-position-in-group-mix', '', 'mega-menu/group1/group-mix/module-position-in-group-mix', '', 'url', 1, 160, 4, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"yj_menu_sub_title":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"2","yj_menu_show_title":"2","yj_mod_id":["31"],"yj_position":["topmenu1"]}', 110, 111, 0, '*', 0),
(180, 'mainmenu', 'GM Group 1', 'gm-group-1', '', 'mega-menu/group1/group-mix/gm-group-1', 'index.php?option=com_content&view=article&id=3', 'component', 1, 160, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 112, 119, 0, '*', 0),
(181, 'mainmenu', 'GM Group 2', 'gm-group-2', '', 'mega-menu/group1/group-mix/gm-group-2', 'index.php?option=com_content&view=article&id=8', 'component', 1, 160, 4, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 120, 127, 0, '*', 0),
(182, 'mainmenu', 'GM G1 Item 1', 'gm-g1-item-1', '', 'mega-menu/group1/group-mix/gm-group-1/gm-g1-item-1', 'index.php?option=com_content&view=article&id=3', 'component', 1, 180, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 113, 114, 0, '*', 0),
(183, 'mainmenu', 'GM G1 Item 2', 'gm-g1-item-2', '', 'mega-menu/group1/group-mix/gm-group-1/gm-g1-item-2', 'index.php?option=com_content&view=article&id=1', 'component', 1, 180, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 115, 116, 0, '*', 0),
(184, 'mainmenu', 'GM G1 Item 3', 'gm-g1-item-3', '', 'mega-menu/group1/group-mix/gm-group-1/gm-g1-item-3', 'index.php?option=com_content&view=article&id=12', 'component', 1, 180, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 117, 118, 0, '*', 0),
(185, 'mainmenu', 'GM G2 Item 1', 'gm-g2-item-1', '', 'mega-menu/group1/group-mix/gm-group-2/gm-g2-item-1', 'index.php?option=com_content&view=article&id=8', 'component', 1, 181, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 121, 122, 0, '*', 0),
(186, 'mainmenu', 'GM G2 Item 2', 'gm-g2-item-2', '', 'mega-menu/group1/group-mix/gm-group-2/gm-g2-item-2', 'index.php?option=com_content&view=article&id=9', 'component', 1, 181, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 123, 124, 0, '*', 0),
(187, 'mainmenu', 'GM G2 Item 3', 'gm-g2-item-3', '', 'mega-menu/group1/group-mix/gm-group-2/gm-g2-item-3', 'index.php?option=com_content&view=article&id=7', 'component', 1, 181, 5, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 125, 126, 0, '*', 0),
(188, 'mainmenu', 'SG1 Item1 Sub item1', 'sg1-item1-sub-item1', '', 'mega-menu/group1/sub-group/sub-group1/sg1-item1/sg1-item1-sub-item1', 'index.php?option=com_content&view=article&id=8', 'component', 1, 172, 6, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/stories\\/13.png","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 90, 91, 0, '*', 0),
(189, 'mainmenu', 'SG1 Item1 Sub item2', 'sg1-item1-sub-item2', '', 'mega-menu/group1/sub-group/sub-group1/sg1-item1/sg1-item1-sub-item2', 'index.php?option=com_content&view=article&id=12', 'component', 1, 172, 6, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/stories\\/10.png","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 92, 93, 0, '*', 0),
(190, 'mainmenu', 'Menus with image1', 'menus-with-image1', '', 'menu-combos/menus-with-image/menus-with-image1', 'index.php?option=com_content&view=article&id=7', 'component', 1, 120, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/stories\\/go_home.png","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 153, 154, 0, '*', 0),
(191, 'mainmenu', 'Menus with image2', 'menus-with-image2', '', 'menu-combos/menus-with-image/menus-with-image2', 'index.php?option=com_content&view=article&id=2', 'component', 1, 120, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/stories\\/tgz.png","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 155, 156, 0, '*', 0),
(192, 'mainmenu', 'Menus with image3', 'menus-with-image3', '', 'menu-combos/menus-with-image/menus-with-image3', 'index.php?option=com_content&view=article&id=12', 'component', 1, 120, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/stories\\/5.png","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 157, 158, 0, '*', 0),
(193, 'mainmenu', 'Menus with sub title1', 'menus-with-sub-title1', '', 'menu-combos/menus-with-sub-title/menus-with-sub-title1', 'index.php?option=com_content&view=article&id=3', 'component', 1, 121, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"Title only  Short description Lorem ipsum dolor sit amet, consectetur adipiscing elit.","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 161, 162, 0, '*', 0),
(194, 'mainmenu', 'Menus with sub title2', 'menus-with-sub-title2', '', 'menu-combos/menus-with-sub-title/menus-with-sub-title2', 'index.php?option=com_content&view=article&id=10', 'component', 1, 121, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"Title only  Short description Lorem ipsum dolor sit amet, consectetur adipiscing elit.","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 163, 164, 0, '*', 0),
(195, 'mainmenu', 'Menus with sub title3', 'menus-with-sub-title3', '', 'menu-combos/menus-with-sub-title/menus-with-sub-title3', 'index.php?option=com_content&view=article&id=3', 'component', 1, 121, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"Title only  Short description Lorem ipsum dolor sit amet, consectetur adipiscing elit.","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 165, 166, 0, '*', 0),
(196, 'mainmenu', 'Menus with image and sub title1', 'menus-with-image-and-sub-title1', '', 'menu-combos/menus-with-image-and-subtitle/menus-with-image-and-sub-title1', 'index.php?option=com_content&view=article&id=3', 'component', 1, 122, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/stories\\/preferences_contact_list.png","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"Title only  Short description Lorem ipsum dolor sit amet, consectetur adipiscing elit.","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 169, 170, 0, '*', 0),
(197, 'mainmenu', 'Menus with image and sub title2', 'menus-with-image-and-sub-title2', '', 'menu-combos/menus-with-image-and-subtitle/menus-with-image-and-sub-title2', 'index.php?option=com_content&view=article&id=3', 'component', 1, 122, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/stories\\/13.png","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"Title only  Short description Lorem ipsum dolor sit amet, consectetur adipiscing elit.","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 171, 172, 0, '*', 0),
(198, 'mainmenu', 'Menus with image and sub title3', 'menus-with-image-and-sub-title3', '', 'menu-combos/menus-with-image-and-subtitle/menus-with-image-and-sub-title3', 'index.php?option=com_content&view=article&id=3', 'component', 1, 122, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"images\\/stories\\/5.png","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"yj_menu_sub_title":"Title only  Short description Lorem ipsum dolor sit amet, consectetur adipiscing elit.","yj_menu_custom_class":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 173, 174, 0, '*', 0),
(200, 'mainmenu', 'Login Module', 'login-module', '', 'login/login-module', '', 'url', 0, 126, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"yj_menu_sub_title":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"1","yj_menu_show_title":"2","yj_mod_id":["16"]}', 198, 199, 0, '*', 0),
(201, 'mainmenu', 'Purple', 'purple', '', 'features/template-styles/purple', '?change_css=purple', 'url', 1, 145, 3, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"yj_menu_sub_title":"","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 47, 48, 0, '*', 0),
(202, 'mainmenu', 'YJ Image Slider 3.0', '2011-05-09-11-33-40', '', 'features/2011-05-09-11-33-40', 'http://www.youjoomla.com/yj-image-slider-3.0.html', 'url', 1, 112, 2, 0, 0, 0, '0000-00-00 00:00:00', 1, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"yj_menu_sub_title":"Joomla Image Slider","yj_group_holder":"0","yj_menu_holder_width":"","yj_menu_groups_count":"0","yj_sub_group_width":"","yj_item_type":"0","yj_menu_show_title":"1"}', 56, 57, 0, '*', 0),
(21, 'menu', 'com_finder', 'Smart Search', '', 'Smart Search', 'index.php?option=com_finder', 'component', 0, 1, 1, 27, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:finder', 0, '', 41, 42, 0, '*', 1);

-- --------------------------------------------------------

--
-- Table structure for table `#__menu_types`
--

DROP TABLE IF EXISTS `#__menu_types`;
CREATE TABLE IF NOT EXISTS `#__menu_types` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) NOT NULL,
  `title` varchar(48) NOT NULL,
  `description` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_menutype` (`menutype`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=3 ;

--
-- Dumping data for table `#__menu_types`
--

INSERT INTO `#__menu_types` (`id`, `menutype`, `title`, `description`) VALUES
(1, 'mainmenu', 'Main Menu', 'The main menu for the site'),
(2, 'footer-menu', 'Footer Menu', 'footer menu');

-- --------------------------------------------------------

--
-- Table structure for table `#__modules`
--

DROP TABLE IF EXISTS `#__modules`;
CREATE TABLE IF NOT EXISTS `#__modules` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `content` text NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  `position` varchar(50) NOT NULL DEFAULT '',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `module` varchar(50) DEFAULT NULL,
  `access` int(10) unsigned DEFAULT NULL,
  `showtitle` tinyint(3) unsigned NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `published` (`published`,`access`),
  KEY `newsfeeds` (`module`,`published`),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=94 ;

--
-- Dumping data for table `#__modules`
--

INSERT INTO `#__modules` (`id`, `title`, `note`, `content`, `ordering`, `position`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `published`, `module`, `access`, `showtitle`, `params`, `client_id`, `language`) VALUES
(1, 'Main Menu', '', '', 1, 'position-6', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 1, 1, '{"menutype":"mainmenu","startLevel":"1","endLevel":"0","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(2, 'Login', '', '', 1, 'login', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_login', 1, 1, '', 1, '*'),
(3, 'Popular Articles', '', '', 3, 'cpanel', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_popular', 3, 1, '{"count":"5","catid":"","user_id":"0","layout":"_:default","moduleclass_sfx":"","cache":"0","automatic_title":"1"}', 1, '*'),
(4, 'Recently Added Articles', '', '', 4, 'cpanel', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_latest', 3, 1, '{"count":"5","ordering":"c_dsc","catid":"","user_id":"0","layout":"_:default","moduleclass_sfx":"","cache":"0","automatic_title":"1"}', 1, '*'),
(6, 'Unread Messages', '', '', 1, 'header', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_unread', 3, 1, '', 1, '*'),
(7, 'Online Users', '', '', 2, 'header', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_online', 3, 1, '', 1, '*'),
(8, 'Toolbar', '', '', 1, 'toolbar', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_toolbar', 3, 1, '', 1, '*'),
(9, 'Quick Icons', '', '', 1, 'icon', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_quickicon', 3, 1, '', 1, '*'),
(10, 'Logged-in Users', '', '', 2, 'cpanel', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_logged', 3, 1, '{"count":"5","name":"1","layout":"_:default","moduleclass_sfx":"","cache":"0","automatic_title":"1"}', 1, '*'),
(12, 'Admin Menu', '', '', 1, 'menu', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 3, 1, '{"layout":"","moduleclass_sfx":"","shownew":"1","showhelp":"1","cache":"0"}', 1, '*'),
(13, 'Admin Submenu', '', '', 1, 'submenu', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_submenu', 3, 1, '', 1, '*'),
(14, 'User Status', '', '', 2, 'status', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_status', 3, 1, '', 1, '*'),
(15, 'Title', '', '', 1, 'title', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_title', 3, 1, '', 1, '*'),
(16, 'Login Form', '', '', 1, 'left', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 0, 'mod_login', 1, 1, '{"pretext":"","posttext":"","login":"","logout":"","greeting":"1","name":"0","usesecure":"0","layout":"_:default","moduleclass_sfx":"","cache":"0"}', 0, '*'),
(17, 'Breadcrumbs', '', '', 1, 'breadcrumb', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_breadcrumbs', 1, 1, '{"showHere":"1","showHome":"1","homeText":"Home","showLast":"1","separator":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(18, 'Banners', '', '', 1, 'position-5', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 0, 'mod_banners', 1, 1, '{"target":"1","count":"1","cid":"1","catid":["27"],"tag_search":"0","ordering":"0","header_text":"","footer_text":"","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900"}', 0, '*'),
(19, 'Main Menu', '', '', 1, 'right', 42, '2011-05-06 12:44:15', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 1, 1, '{"menutype":"mainmenu","startLevel":"1","endLevel":"0","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(20, 'Top1', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas.   Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et  urna  id elit onvali', 1, 'top1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(21, 'Top5', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas.   Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et  urna  id elit onvali', 1, 'top5', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(22, 'Top2', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas.   Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et  urna  id elit onvali', 1, 'top2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(23, 'Top4', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas.   Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et  urna  id elit onvali', 1, 'top4', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(24, 'Top3', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas.   Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et  urna  id elit onvali', 1, 'top3', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(25, 'Header1', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in.', 1, 'header1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(26, 'Header3', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in.', 1, 'header3', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(27, 'Header2', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in.', 1, 'header2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(28, 'User6', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali', 1, 'user6', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(29, 'Adv1', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali', 1, 'adv1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(30, 'Adv5', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali', 1, 'adv5', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(31, 'Adv2', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali', 1, 'adv2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(32, 'Adv4', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali', 1, 'adv4', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(33, 'Adv3', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali', 1, 'adv3', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(34, 'User1', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali', 1, 'user1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(35, 'User2', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali', 1, 'user2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(36, 'User3', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali', 1, 'user3', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(37, 'User4', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali', 1, 'user4', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(38, 'User5', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali', 1, 'user5', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(39, 'User7', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali', 1, 'user7', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(40, 'User11', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali', 1, 'user11', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(41, 'User9', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali', 1, 'user9', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(42, 'User10', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali', 1, 'user10', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(43, 'User8', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali', 1, 'user8', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(44, 'User12', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali', 1, 'user12', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(45, 'User13', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali', 1, 'user13', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(46, 'User14', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali', 1, 'user14', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(47, 'User15', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali', 1, 'user15', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(48, 'User16', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali', 1, 'user16', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(49, 'User17', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali', 1, 'user17', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(50, 'User18', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali', 1, 'user18', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(51, 'User19', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali', 1, 'user19', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(52, 'User20', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali', 1, 'user20', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(53, 'User21', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali', 1, 'user21', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(54, 'User22', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali', 1, 'user22', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(55, 'User23', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali', 1, 'user23', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(56, 'User24', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali', 1, 'user24', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(57, 'User25', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali', 1, 'user25', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(58, 'Bodytop1', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euismod convas. Nunc sodales lorem vitae magna ac vestibulum turpis interdum. Phasel lus et urna id elit euismod convallis', 1, 'bodytop1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(59, 'Bodytop2', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euismod convas. Nunc sodales lorem vitae magna ac vestibulum turpis interdum. Phasel lus et urna id elit euismod convallis', 1, 'bodytop2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(60, 'Bodytop3', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euismod convas. Nunc sodales lorem vitae magna ac vestibulum turpis interdum. Phasel lus et urna id elit euismod convallis', 1, 'bodytop3', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(61, 'Bodybottom1', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euismod convas. Nunc sodales lorem vitae magna ac vestibulum turpis interdum. Phasel lus et urna id elit euismod convallis', 1, 'bodybottom1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(62, 'Bodybottom2', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euismod convas. Nunc sodales lorem vitae magna ac vestibulum turpis interdum. Phasel lus et urna id elit euismod convallis', 1, 'bodybottom2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(63, 'Bodybottom3', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euismod convas. Nunc sodales lorem vitae magna ac vestibulum turpis interdum. Phasel lus et urna id elit euismod convallis', 1, 'bodybottom3', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(64, 'InsetTop', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali,Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali,Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis inNunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali,Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpisinAv vestibulum turpis interdum.Pha sellus et urna id elit euism convas.Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum ', 1, 'insettop', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(65, 'InsetBottom', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali,Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali,Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis inNunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali,Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpisinAv vestibulum turpis interdum.Pha sellus et urna id elit euism convas.Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum.', 1, 'insetbottom', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(66, 'Left', '', 'Praesent posuere tempus nibh bibendum aliquam. Integer ullamcorper vestibulum nisl vitae ullamcorper. Donec fermentum ligula at tortor tincidunt rutrum. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Quisque blandit tellus vitae justo rutrum viverra. Proin semper sapien faucibus dolor ultrices a tempus leo porta. Integer sed lorem nisl, ac tincidunt diam.ed ante felis, pellentesque in consectetur at, rutrum non turpis. Aenean id pellentesque lacus. Quisque ligula est, aliquam', 1, 'left', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(67, 'Right', '', 'Praesent posuere tempus nibh bibendum aliquam. Integer ullamcorper vestibulum nisl vitae ullamcorper. Donec fermentum ligula at tortor tincidunt rutrum. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Quisque blandit tellus vitae justo rutrum viverra. Proin semper sapien faucibus dolor ultrices a tempus leo porta. Integer sed lorem nisl, ac tincidunt diam.ed ante felis, pellentesque in consectetur at, rutrum non turpis. Aenean id pellentesque lacus. Quisque ligula est, aliquam', 1, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(68, 'Inset', '', 'Praesent posuere tempus nibh bibendum aliquam. Integer ullamcorper vestibulum nisl vitae ullamcorper. Donec fermentum ligula at tortor tincidunt rutrum. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Quisque blandit tellus vitae justo rutrum viverra. Proin semper sapien faucibus dolor ultrices a tempus leo porta. Integer sed lorem nisl, ac tincidunt diam.ed ante felis, pellentesque in consectetur at, rutrum non turpis. Aenean id pellentesque lacus. Quisque ligula est, aliquam', 1, 'inset', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(69, 'Mobile Login', '', '', 1, 'mobilelogin', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_login', 1, 1, '{"pretext":"","posttext":"","login":"","logout":"","greeting":"1","name":"0","usesecure":"0","layout":"_:default","moduleclass_sfx":"","cache":"0"}', 0, '*'),
(70, 'Mobile Search', '', '', 0, 'mobilesearch', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_search', 1, 1, '{"label":"","width":"20","text":"","button":"","button_pos":"right","imagebutton":"","button_text":"","set_itemid":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(71, 'Mobiletop', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali', 1, 'mobiletop', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(72, 'Mobilebottom', '', 'Av vestibulum turpis interdum. Pha sellus et urna id elit euism convas. Nunc sodales lorem vit magna ac vestibulum turpis in. Phasel lus et urna id elit onvali', 1, 'mobilebottom', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(73, 'Breadcrumbs', '', '', 1, 'breadcrumb', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_breadcrumbs', 1, 1, '{"showHere":"1","showHome":"1","homeText":"Home","showLast":"1","separator":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(75, 'Footer Menu', '', '', 1, 'footer', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 1, 1, '{"menutype":"footer-menu","startLevel":"1","endLevel":"0","showAllChildren":"0","tag_id":"","class_sfx":"-nav","window_open":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(76, 'Menu Module Position Demo', '', '<img src="images/stories/modulepoz.jpg" border="0" alt="modulepoz" width="160" height="42" style="display: block; margin-left: auto; margin-right: auto;" />\r\n<p>This module is published in module position topmenu1.</p>', 1, 'topmenu1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(77, 'Twitter Updates', '', '', 1, 'user22', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_yj_twitter', 1, 1, '{"twitter_user":"youjoomla","nr_article":"2","tweet_limit":"60","tweet_link":"1","tweet_date":"1","tweet_follow":"0","tweet_image":"0","moduleclass_sfx":""}', 0, '*'),
(78, 'YJ Images Slider V3', '', '', 1, 'adv1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_yjis3', 1, 0, '{"moduleclass_sfx":"_yjis","is_copy":"","swidth":"980","sheight":"460","sorient":"0","type_slider":"0","start_slide":"0","stime":"6000","sduration":"600","smenu":"0","pagination":"1","balons":"0","order":"0","over_opacity":"0.7","loop_image":"false","use_NB":"true","slide_image_1":"-1","slide_title_1":"","slide_description_1":"","slide_intro_1":"<span class=\\"stitle\\">We are <span class=\\"diff\\">web designers<\\/span>-We bring color to your website<\\/span>\\r\\n<span class=\\"i_text\\">Ipasco lorames opus dalakom dolor sit amet, consectetur adipiscing elit. Aliquam velit dolor, luctus sit amet ultricies vitae, pellentesque in risus. Donec non massa tempus elit adipiscing.Praesent non justo risus, nec blandit sapien.<\\/span>","mbox_1":"0","mboxlink_1":"","mboxtype_1":"0","video_width_1":"640","video_height_1":"360","image_group_1":"0","image_group_name_1":"yjgallery","slide_link_1":"","slide_open_1":"0","slide_image_2":"sliders2.jpg","slide_title_2":"","slide_description_2":"","slide_intro_2":"<span class=\\"stitle\\">We are <span class=\\"diff\\">masters in<\\/span>-Graphics and Logo development<\\/span>\\r\\n<span class=\\"i_text\\">Ipasco lorames opus dalakom dolor sit amet, consectetur adipiscing elit. Aliquam velit dolor, luctus sit amet ultricies vitae, pellentesque in risus. Donec non massa tempus elit adipiscing.Praesent non justo risus, nec blandit sapien.<\\/span>","mbox_2":"0","mboxlink_2":"","mboxtype_2":"0","video_width_2":"640","video_height_2":"360","image_group_2":"0","image_group_name_2":"yjgallery","slide_link_2":"","slide_open_2":"0","slide_image_3":"sliders3.jpg","slide_title_3":"","slide_description_3":"","slide_intro_3":"<span class=\\"stitle\\">We are<span class=\\"diff\\"> leaders in<\\/span>-Print , Media and web development<\\/span>\\r\\n<span class=\\"i_text\\">Ipasco lorames opus dalakom dolor sit amet, consectetur adipiscing elit. Aliquam velit dolor, luctus sit amet ultricies vitae, pellentesque in risus. Donec non massa tempus elit adipiscing.Praesent non justo risus, nec blandit sapien.<\\/span>","mbox_3":"0","mboxlink_3":"","mboxtype_3":"0","video_width_3":"640","video_height_3":"360","image_group_3":"0","image_group_name_3":"yjgallery","slide_link_3":"","slide_open_3":"0","slide_image_4":"","slide_title_4":"","slide_description_4":"","slide_intro_4":"","mbox_4":"0","mboxlink_4":"","mboxtype_4":"0","video_width_4":"640","video_height_4":"360","image_group_4":"0","image_group_name_4":"yjgallery","slide_link_4":"","slide_open_4":"0","slide_image_5":"","slide_title_5":"","slide_description_5":"","slide_intro_5":"","mbox_5":"0","mboxlink_5":"","mboxtype_5":"0","video_width_5":"640","video_height_5":"360","image_group_5":"0","image_group_name_5":"yjgallery","slide_link_5":"","slide_open_5":"0","slide_image_6":"","slide_title_6":"","slide_description_6":"","slide_intro_6":"","mbox_6":"0","mboxlink_6":"","mboxtype_6":"0","video_width_6":"640","video_height_6":"360","image_group_6":"0","image_group_name_6":"yjgallery","slide_link_6":"","slide_open_6":"0","slide_image_7":"","slide_title_7":"","slide_description_7":"","slide_intro_7":"","mbox_7":"0","mboxlink_7":"","mboxtype_7":"0","video_width_7":"640","video_height_7":"360","image_group_7":"0","image_group_name_7":"yjgallery","slide_link_7":"","slide_open_7":"0","slide_image_8":"","slide_title_8":"","slide_description_8":"","slide_intro_8":"","mbox_8":"0","mboxlink_8":"","mboxtype_8":"0","video_width_8":"640","video_height_8":"360","image_group_8":"0","image_group_name_8":"yjgallery","slide_link_8":"","slide_open_8":"0","slide_image_9":"","slide_title_9":"","slide_description_9":"","slide_intro_9":"","mbox_9":"0","mboxlink_9":"","mboxtype_9":"0","video_width_9":"640","video_height_9":"360","image_group_9":"0","image_group_name_9":"yjgallery","slide_link_9":"","slide_open_9":"0","slide_image_10":"","slide_title_10":"","slide_description_10":"","slide_intro_10":"","mbox_10":"0","mboxlink_10":"","mboxtype_10":"0","video_width_10":"640","video_height_10":"360","image_group_10":"0","image_group_name_10":"yjgallery","slide_link_10":"","slide_open_10":"0","slide_image_11":"","slide_title_11":"","slide_description_11":"","slide_intro_11":"","mbox_11":"0","mboxlink_11":"","mboxtype_11":"0","video_width_11":"640","video_height_11":"360","image_group_11":"0","image_group_name_11":"yjgallery","slide_link_11":"","slide_open_11":"0","slide_image_12":"","slide_title_12":"","slide_description_12":"","slide_intro_12":"","mbox_12":"0","mboxlink_12":"","mboxtype_12":"0","video_width_12":"640","video_height_12":"360","image_group_12":"0","image_group_name_12":"yjgallery","slide_link_12":"","slide_open_12":"0","slide_image_13":"","slide_title_13":"","slide_description_13":"","slide_intro_13":"","mbox_13":"0","mboxlink_13":"","mboxtype_13":"0","video_width_13":"640","video_height_13":"360","image_group_13":"0","image_group_name_13":"yjgallery","slide_link_13":"","slide_open_13":"0","slide_image_14":"","slide_title_14":"","slide_description_14":"","slide_intro_14":"","mbox_14":"0","mboxlink_14":"","mboxtype_14":"0","video_width_14":"640","video_height_14":"360","image_group_14":"0","image_group_name_14":"yjgallery","slide_link_14":"","slide_open_14":"0","slide_image_15":"","slide_title_15":"","slide_description_15":"","slide_intro_15":"","mbox_15":"0","mboxlink_15":"","mboxtype_15":"0","video_width_15":"640","video_height_15":"360","image_group_15":"0","image_group_name_15":"yjgallery","slide_link_15":"","slide_open_15":"0","slide_image_16":"","slide_title_16":"","slide_description_16":"","slide_intro_16":"","mbox_16":"0","mboxlink_16":"","mboxtype_16":"0","video_width_16":"640","video_height_16":"360","image_group_16":"0","image_group_name_16":"yjgallery","slide_link_16":"","slide_open_16":"0","slide_image_17":"","slide_title_17":"","slide_description_17":"","slide_intro_17":"","mbox_17":"0","mboxlink_17":"","mboxtype_17":"0","video_width_17":"640","video_height_17":"360","image_group_17":"0","image_group_name_17":"yjgallery","slide_link_17":"","slide_open_17":"0","slide_image_18":"","slide_title_18":"","slide_description_18":"","slide_intro_18":"","mbox_18":"0","mboxlink_18":"","mboxtype_18":"0","video_width_18":"640","video_height_18":"360","image_group_18":"0","image_group_name_18":"yjgallery","slide_link_18":"","slide_open_18":"0","slide_image_19":"","slide_title_19":"","slide_description_19":"","slide_intro_19":"","mbox_19":"0","mboxlink_19":"","mboxtype_19":"0","video_width_19":"640","video_height_19":"360","image_group_19":"0","image_group_name_19":"yjgallery","slide_link_19":"","slide_open_19":"0","slide_image_20":"","slide_title_20":"","slide_description_20":"","slide_intro_20":"","mbox_20":"0","mboxlink_20":"","mboxtype_20":"0","video_width_20":"640","video_height_20":"360","image_group_20":"0","image_group_name_20":"yjgallery","slide_link_20":"","slide_open_20":"0"}', 0, '*'),
(79, 'We bring you creative web designs', '', '<p><img src="images/stories/creative.gif" border="0" alt="creative" width="180" height="96" style="margin-right: 10px; float: left;" />Nulla  facilisi. Donec nec lorem eu erat vulputate tincidunt et imperdiet  orci. Pellentesque non tortor sit amet turpis aliquet sodales ut quis  nisi. Donec dapibus dolor ac arcu adipiscing congue ac eget diam.</p>', 1, 'user1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(80, 'Let us manage your web services', '', '<p><img style="margin-right: 10px; float: left;" alt="services" src="images/stories/services.jpg" height="96" width="180" />Nulla facilisi. Donec nec lorem eu erat vulputate tincidunt et imperdiet orci. Pellentesque non tortor sit amet turpis aliquet sodales ut quis nisi. Donec dapibus dolor ac arcu adipiscing congue ac eget diam.</p>', 1, 'user2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(81, 'Our Services', '', '<h2 class="front_title">Our Services</h2>\r\n<p>Caest dans laenceinte daune ancien<br />ecole que ldequipe deImpala Web<br />active ses msninges et sa creativit</p>\r\n<a class="readon" href="#"><span> View more</span></a>', 1, 'user6', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(82, 'Web Development', '', '<div class="development"></div>\r\n<p>Caest dans laenceinte daune ancien<br />ecole que ldequipe deImpala Web<br />active ses msninges et sa creativit</p>\r\n<ul>\r\n<li>Wordpress development</li>\r\n<li>e-Commerce development</li>\r\n<li>PHP development</li>\r\n<li>Joomla Customization</li>\r\n</ul>', 1, 'user7', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(83, 'Print Media', '', '<div class="media"></div>\r\n<p>Caest dans laenceinte daune ancien<br />ecole que ldequipe deImpala Web<br />active ses msninges et sa creativit</p>\r\n<ul>\r\n<li>Brochure designing</li>\r\n<li>Corporate identity</li>\r\n<li>Email template designing</li>\r\n<li>Logo designing</li>\r\n</ul>', 1, 'user8', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(84, 'PSD to XHTML', '', '<div class="psd"></div>\r\n<p>Caest dans laenceinte daune ancien<br />ecole que ldequipe deImpala Web<br />active ses msninges et sa creativit</p>\r\n<ul>\r\n<li>Hand Coded XHTML Strict Markup</li>\r\n<li>Light-weight Tableless CSS Layout</li>\r\n<li>Semantic Markup used for SEO</li>\r\n<li>Clean W3C Valid XHTML / CSS</li>\r\n</ul>', 1, 'user9', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(85, 'Recent Projects', '', '<h2 class="front_title">Recent Projects</h2>\r\n<p>Caest dans laenceinte daune ancien<br />ecole que ldequipe deImpala Web<br />active ses msninges et sa creativit</p>\r\n<a class="readon" href="#"><span> View more</span></a>', 1, 'user11', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(86, 'Youmedia project', '', '<img alt="youmedia" src="images/stories/youmedia.jpg" height="120" width="220" /><br /><span class="project_name">Youmedia Template</span><strong>Portfolio Joomla Template</strong><br />Url : <a target="_blank" href="http://www.joomla1.5.youjoomla.info/youmedia/">Visit Youmedia Demo</a><br />', 1, 'user12', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(87, 'Youmomentum  project', '', '<img alt="youmedia" src="images/stories/youmomentum.jpg" height="120" width="220" /><br /><span class="project_name">Youmomentum Template</span><strong>Cars Joomla Template</strong><br />Url : <a target="_blank" href="http://wordpress.youjoomla.net/youmomentum/">Visit Youmometum Demo</a><br />', 1, 'user13', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(88, 'Youphoto  project', '', '<img alt="youmedia" src="images/stories/youphoto.jpg" height="120" width="220" /><br /><span class="project_name">Youphoto Template</span><strong>Blog Joomla Template</strong><br />Url : <a target="_blank" href="http://www.joomla1.5.youjoomla.info/youphoto/">Visit Youphoto Demo</a><br />', 1, 'user14', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(89, 'Company Info', '', '<div class="bootom_logo"></div>\r\nContact details will be appear here <br />contact details here<br /><br />Phone No. : 00 123 254-1234<br />E-mail : info@companynamr.com', 1, 'user21', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(90, 'Testimonials', '', '<p>Donec risus tortor, mattis id pulvinar in, pulvinar non ipsum. Etiam in.</p>\r\n<p>Nam auctor, justo quis condimentum molestie, justo ligula  imperdiet risus.</p>\r\n<a href="#">-John Sayton</a>', 1, 'user23', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(91, 'Get Social', '', '<p>Follow us on below applications<br />and be upadated.</p>\r\n<a class="tweet" href="#"></a> <a class="face" href="#"></a> <a class="linkedin" href="#"></a>', 1, 'user24', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(92, 'Multilanguage status', '', '', 1, 'status', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 0, 'mod_multilangstatus', 3, 1, '{"layout":"_:default","moduleclass_sfx":"","cache":"0"}', 1, '*'),
(93, 'Multilanguage status', '', '', 1, 'status', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 0, 'mod_multilangstatus', 3, 1, '{"layout":"_:default","moduleclass_sfx":"","cache":"0"}', 1, '*');

-- --------------------------------------------------------

--
-- Table structure for table `#__modules_menu`
--

DROP TABLE IF EXISTS `#__modules_menu`;
CREATE TABLE IF NOT EXISTS `#__modules_menu` (
  `moduleid` int(11) NOT NULL DEFAULT '0',
  `menuid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`moduleid`,`menuid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `#__modules_menu`
--

INSERT INTO `#__modules_menu` (`moduleid`, `menuid`) VALUES
(1, 0),
(2, 0),
(3, 0),
(4, 0),
(6, 0),
(7, 0),
(8, 0),
(9, 0),
(10, 0),
(12, 0),
(13, 0),
(14, 0),
(15, 0),
(16, 101),
(17, 102),
(17, 103),
(17, 104),
(17, 105),
(17, 106),
(17, 107),
(17, 108),
(17, 109),
(17, 110),
(17, 111),
(17, 112),
(17, 113),
(17, 114),
(17, 115),
(17, 116),
(17, 117),
(17, 118),
(18, 0),
(19, 138),
(20, 104),
(21, 104),
(22, 104),
(23, 104),
(24, 104),
(25, 104),
(26, 104),
(27, 104),
(28, 104),
(29, 104),
(30, 104),
(31, 104),
(32, 104),
(33, 104),
(34, 104),
(35, 104),
(36, 104),
(37, 104),
(38, 104),
(39, 104),
(40, 104),
(41, 104),
(42, 104),
(43, 104),
(44, 104),
(45, 104),
(46, 104),
(47, 104),
(48, 104),
(49, 104),
(50, 104),
(51, 104),
(52, 104),
(53, 104),
(54, 104),
(55, 104),
(56, 104),
(57, 104),
(58, 104),
(59, 104),
(60, 104),
(61, 104),
(62, 104),
(63, 104),
(64, 104),
(65, 104),
(66, 104),
(67, 104),
(68, 104),
(69, 0),
(70, 0),
(71, 101),
(72, 101),
(73, 102),
(73, 103),
(73, 104),
(73, 105),
(73, 106),
(73, 107),
(73, 108),
(73, 109),
(73, 110),
(73, 111),
(73, 112),
(73, 113),
(73, 115),
(73, 116),
(73, 117),
(73, 118),
(73, 119),
(73, 120),
(73, 121),
(73, 122),
(73, 123),
(73, 124),
(73, 125),
(73, 126),
(73, 129),
(73, 131),
(73, 132),
(73, 133),
(73, 134),
(73, 135),
(73, 136),
(73, 137),
(73, 138),
(73, 139),
(73, 140),
(73, 141),
(73, 142),
(73, 143),
(73, 144),
(73, 145),
(73, 146),
(73, 147),
(73, 148),
(73, 149),
(73, 150),
(73, 151),
(73, 152),
(73, 153),
(73, 154),
(73, 155),
(73, 156),
(73, 157),
(75, 0),
(76, 0),
(77, 101),
(78, 101),
(79, 101),
(80, 101),
(81, 101),
(82, 101),
(83, 101),
(84, 101),
(85, 101),
(86, 101),
(87, 101),
(88, 101),
(89, 101),
(90, 101),
(91, 101),
(92, 0),
(93, 0);

-- --------------------------------------------------------

--
-- Table structure for table `#__newsfeeds`
--

DROP TABLE IF EXISTS `#__newsfeeds`;
CREATE TABLE IF NOT EXISTS `#__newsfeeds` (
  `catid` int(11) NOT NULL DEFAULT '0',
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `link` varchar(200) NOT NULL DEFAULT '',
  `filename` varchar(200) DEFAULT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `numarticles` int(10) unsigned NOT NULL DEFAULT '1',
  `cache_time` int(10) unsigned NOT NULL DEFAULT '3600',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rtl` tinyint(4) NOT NULL DEFAULT '0',
  `access` int(10) unsigned DEFAULT NULL,
  `language` char(7) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=3 ;

--
-- Dumping data for table `#__newsfeeds`
--

INSERT INTO `#__newsfeeds` (`catid`, `id`, `name`, `alias`, `link`, `filename`, `published`, `numarticles`, `cache_time`, `checked_out`, `checked_out_time`, `ordering`, `rtl`, `access`, `language`, `params`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `xreference`, `publish_up`, `publish_down`) VALUES
(5, 1, 'Youjoomla', 'youjoomla', 'http://www.youjoomla.com/rss/', NULL, 1, 5, 3600, 0, '0000-00-00 00:00:00', 1, 0, 1, '*', '{"show_feed_image":"","show_feed_description":"","show_item_description":"","feed_character_count":"0","newsfeed_layout":""}', '2011-01-29 15:25:11', 42, '', '0000-00-00 00:00:00', 0, '', '', '{"robots":"","rights":""}', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(5, 2, 'Joomla', 'joomla', 'http://feeds.joomla.org/JoomlaAnnouncements', NULL, 1, 5, 3600, 0, '0000-00-00 00:00:00', 2, 0, 1, '*', '{"show_feed_image":"0","show_feed_description":"","show_item_description":"","feed_character_count":"200","newsfeed_layout":""}', '2011-01-29 15:29:04', 42, '', '2011-01-29 15:29:40', 42, '', '', '{"robots":"","rights":""}', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00');

-- --------------------------------------------------------

--
-- Table structure for table `#__overrider`
--

DROP TABLE IF EXISTS `#__overrider`;
CREATE TABLE IF NOT EXISTS `#__overrider` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `constant` varchar(255) NOT NULL,
  `string` text NOT NULL,
  `file` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Table structure for table `#__schemas`
--

DROP TABLE IF EXISTS `#__schemas`;
CREATE TABLE IF NOT EXISTS `#__schemas` (
  `extension_id` int(11) NOT NULL,
  `version_id` varchar(20) NOT NULL,
  PRIMARY KEY (`extension_id`,`version_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `#__schemas`
--

INSERT INTO `#__schemas` (`extension_id`, `version_id`) VALUES
(700, '2.5.0-2012-01-14');

-- --------------------------------------------------------

--
-- Table structure for table `#__template_styles`
--

DROP TABLE IF EXISTS `#__template_styles`;
CREATE TABLE IF NOT EXISTS `#__template_styles` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `template` varchar(50) NOT NULL DEFAULT '',
  `client_id` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `home` char(7) NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_template` (`template`),
  KEY `idx_home` (`home`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=10 ;

--
-- Dumping data for table `#__template_styles`
--

INSERT INTO `#__template_styles` (`id`, `template`, `client_id`, `home`, `title`, `params`) VALUES
(2, 'bluestork', 1, '1', 'Bluestork - Default', '{"useRoundedCorners":"1","showSiteName":"0"}'),
(3, 'atomic', 0, '0', 'Atomic - Default', '{}'),
(4, 'beez_20', 0, '0', 'Beez2 - Default', '{"wrapperSmall":53,"wrapperLarge":72,"logo":"images\\/joomla_black.gif","sitetitle":"Joomla!","sitedescription":"Open Source Content Management","navposition":"left","templatecolor":"personal"}'),
(5, 'hathor', 1, '0', 'Hathor - Default', '{"showSiteName":"0","colourChoice":"","boldText":"0"}'),
(6, 'beez5', 0, '0', 'Beez5 - Default-Fruit Shop', '{"wrapperSmall":"53","wrapperLarge":"72","logo":"images\\/sampledata\\/fruitshop\\/fruits.gif","sitetitle":"Matuna Market ","sitedescription":"Fruit Shop Sample Site","navposition":"left","html5":"0"}'),
(9, 'youdesigns', 0, '1', 'Youdesigns - Default', '{"custom_css":"2","default_color":"blue","default_font":"3","default_font_family":"6","selectors_override":"1","selectors_override_type":"3","css_font_family":"12","google_font_family":"2","cufon_font_family":"11","affected_selectors":"div.title h1,div.title h2,div.componentheading, h1,h2,h3,h4,h5,h6,.yjround h4,.yjsquare h4,span.stitle","logo_height":"80px","logo_width":"250px","turn_logo_off":"2","turn_header_block_off":"2","call_us":"1","call_us_text":"Give Us a Call:012-345-678","menuName":"mainmenu","default_menu_style":"2","sub_width":"280px","yjsg_menu_offset":"95","css_widthdefined":"px","css_width":"980","site_layout":"2","widthdefined":"%","maincolumn":"55","insetcolumn":"0","leftcolumn":"22.5","rightcolumn":"22.5","widthdefined_itmid":"%","maincolumn_itmid":"46","insetcolumn_itmid":"18","leftcolumn_itmid":"18","rightcolumn_itmid":"18","define_itemid":["104"],"yjsg_1_width":"20|20|20|20|20|0|0|0|0|0","yjsg_2_width":"20|20|20|20|20|0|0|0|0|0","yjsg_3_width":"20|20|20|20|20|0|0|0|0|0","yjsg_4_width":"20|20|20|20|20|0|0|0|0|0","yjsg_bodytop_width":"33|33|33|0|0|0","yjsg_yjsgbodytbottom_width":"33|33|33|0|0|0","yjsg_5_width":"20|20|20|20|20|0|0|0|0|0","yjsg_6_width":"20|20|20|20|20|0|0|0|0|0","yjsg_7_width":"20|20|20|20|20|0|0|0|0|0","iphone_default":"1","android_default":"1","handheld_default":"2","mobile_reg":"1","ga_switch":"0","GAcode":"UA-xxxxxx-x","compress":"0","ie6notice":"0","nonscript":"0","show_tools":"1","show_fres":"1","show_rtlc":"1","text_direction":"2","turn_seo_off":"2","branding_off":"2","joomlacredit_off":"1","fp_controll_switch":"2","fp_chars_limit":"3000","fp_after_text":"","jq_switch":"2","YJsg1_module_style":"YJsgxhtml","YJsgh_module_style":"YJsgxhtml","YJsg2_module_style":"YJsgxhtml","YJsg3_module_style":"YJsgxhtml","YJsg4_module_style":"YJsgxhtml","YJsgmt_module_style":"YJsgxhtml","YJsgl_module_style":"YJsgxhtml","YJsgr_module_style":"YJsgxhtml","YJsgi_module_style":"YJsgxhtml","YJsgit_module_style":"YJsgxhtml","YJsgib_module_style":"YJsgxhtml","YJsgmb_module_style":"YJsgxhtml","YJsg5_module_style":"YJsgxhtml","YJsg6_module_style":"YJsgxhtml","YJsg7_module_style":"YJsgxhtml","component_switch":["101"],"admin_css_time":"1304689039"}');

-- --------------------------------------------------------

--
-- Table structure for table `#__updates`
--

DROP TABLE IF EXISTS `#__updates`;
CREATE TABLE IF NOT EXISTS `#__updates` (
  `update_id` int(11) NOT NULL AUTO_INCREMENT,
  `update_site_id` int(11) DEFAULT '0',
  `extension_id` int(11) DEFAULT '0',
  `categoryid` int(11) DEFAULT '0',
  `name` varchar(100) DEFAULT '',
  `description` text NOT NULL,
  `element` varchar(100) DEFAULT '',
  `type` varchar(20) DEFAULT '',
  `folder` varchar(20) DEFAULT '',
  `client_id` tinyint(3) DEFAULT '0',
  `version` varchar(10) DEFAULT '',
  `data` text NOT NULL,
  `detailsurl` text NOT NULL,
  `infourl` text NOT NULL,
  PRIMARY KEY (`update_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Available Updates' AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Table structure for table `#__update_categories`
--

DROP TABLE IF EXISTS `#__update_categories`;
CREATE TABLE IF NOT EXISTS `#__update_categories` (
  `categoryid` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(20) DEFAULT '',
  `description` text NOT NULL,
  `parent` int(11) DEFAULT '0',
  `updatesite` int(11) DEFAULT '0',
  PRIMARY KEY (`categoryid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Update Categories' AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Table structure for table `#__update_sites`
--

DROP TABLE IF EXISTS `#__update_sites`;
CREATE TABLE IF NOT EXISTS `#__update_sites` (
  `update_site_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) DEFAULT '',
  `type` varchar(20) DEFAULT '',
  `location` text NOT NULL,
  `enabled` int(11) DEFAULT '0',
  `last_check_timestamp` bigint(20) DEFAULT '0',
  PRIMARY KEY (`update_site_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='Update Sites' AUTO_INCREMENT=3 ;

--
-- Dumping data for table `#__update_sites`
--

INSERT INTO `#__update_sites` (`update_site_id`, `name`, `type`, `location`, `enabled`, `last_check_timestamp`) VALUES
(1, 'Joomla Core', 'collection', 'http://update.joomla.org/core/list.xml', 1, 1327456068),
(2, 'Joomla Extension Directory', 'collection', 'http://update.joomla.org/jed/list.xml', 1, 1327456068);

-- --------------------------------------------------------

--
-- Table structure for table `#__update_sites_extensions`
--

DROP TABLE IF EXISTS `#__update_sites_extensions`;
CREATE TABLE IF NOT EXISTS `#__update_sites_extensions` (
  `update_site_id` int(11) NOT NULL DEFAULT '0',
  `extension_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`update_site_id`,`extension_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Links extensions to update sites';

--
-- Dumping data for table `#__update_sites_extensions`
--

INSERT INTO `#__update_sites_extensions` (`update_site_id`, `extension_id`) VALUES
(1, 700),
(2, 700);

-- --------------------------------------------------------

--
-- Table structure for table `#__weblinks`
--

DROP TABLE IF EXISTS `#__weblinks`;
CREATE TABLE IF NOT EXISTS `#__weblinks` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `catid` int(11) NOT NULL DEFAULT '0',
  `sid` int(11) NOT NULL DEFAULT '0',
  `title` varchar(250) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `url` varchar(250) NOT NULL DEFAULT '',
  `description` text NOT NULL,
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(11) NOT NULL DEFAULT '0',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `archived` tinyint(1) NOT NULL DEFAULT '0',
  `approved` tinyint(1) NOT NULL DEFAULT '1',
  `access` int(11) NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `language` char(7) NOT NULL DEFAULT '',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if link is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=3 ;

--
-- Dumping data for table `#__weblinks`
--

INSERT INTO `#__weblinks` (`id`, `catid`, `sid`, `title`, `alias`, `url`, `description`, `date`, `hits`, `state`, `checked_out`, `checked_out_time`, `ordering`, `archived`, `approved`, `access`, `params`, `language`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `featured`, `xreference`, `publish_up`, `publish_down`) VALUES
(1, 6, 0, 'Youjoomla.com', 'youjoomlacom', 'http://www.youjoomla.com', 'Youjoomla.com is Web Development Company specializing in Joomla Templates and Extensions Development. We provide Joomla Quality Service since 2006. Beside our Joomla portfolio we have good experience in other CMS templating like WordPress. and we also offer  clean XHTML/CSS web templates services.', '0000-00-00 00:00:00', 2, 1, 0, '0000-00-00 00:00:00', 1, 0, 1, 1, '{"target":"1","width":"","height":"","count_clicks":""}', '*', '2011-01-29 14:02:16', 42, '', '2011-01-29 14:04:41', 42, '', '', '', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(2, 6, 0, 'Joomla!', 'joomla', 'http://www.joomla.org', 'Joomla! - the dynamic portal engine and content management system.', '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 2, 0, 1, 1, '{"target":"1","width":"","height":"","count_clicks":""}', '*', '2011-01-29 14:04:02', 42, '', '2011-01-29 14:04:31', 42, '', '', '', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00');
